package ist.palcom.hgraph;

/**
 * AbstractListener implements the basic functionality of the Listener interface
 */
public abstract class AbstractListener implements Listener{
	
	private String name;
	private String description;
	protected Path returnPath;
	protected IHgraphNode node;
	
	public AbstractListener(String name, String description, Path returnPath){
		this.name = name;
		this.description = description;
		this.returnPath = returnPath;
	}
	
	public void setNode(IHgraphNode node){
		this.node = node;
	}
	
	protected void callback(String command, Value value){
		if(returnPath != null){
			node.getFuncFunc().getGenericInvokator().invoke(command, returnPath, value);			
		}
	}
	
	public String getDescription() {
		return description;
	}

	public String getName() {
		return name;
	}

	public Path getReturnPath() {
		return returnPath;
	}

	public abstract void trigger(String command, Value params, Path callerPath);

}
