package ist.palcom.hgraph;

public class FuncHandler extends AbstractHandler{

	public static final String name = "Functionality Handler";
	public static final String description = "Handles node functionality assets: Handlers, Invokators and Listeners";
	private Signature[] handlerSignatures;
	
	/**
	 * Command for adding a listener the node. 
	 */
	public static final String CMD_ADDLISTENER = "cmd_addlistener";
	/**
	 * Command for adding a listener the node. 
	 */
	public static final String CMD_ADDHANDLER = "cmd_addhandler";
	/**
	 * Command for adding a listener the node. 
	 */
	public static final String CMD_ADDINVOKATOR = "cmd_addinvokator";

	public static final String CMD_REMOVEINVOKATOR = "cmd_removeinvokator";

	public static final String CMD_REMOVELISTENER = "cmd_removelistener";

	public static final String CMD_REMOVEHANDLER = "cmd_removehandler";
	
	
	private HgraphNode node;

	public FuncHandler(HgraphNode node){
		super(name, description);
		this.node = node;
		handlerSignatures = new Signature[6];
		handlerSignatures[0] = new Signature(new String[]{"Listener"}, CMD_ADDLISTENER, "");
		handlerSignatures[1] = new Signature(new String[]{"Invokator"}, CMD_ADDINVOKATOR, "");
		handlerSignatures[2] = new Signature(new String[]{"Handler"}, CMD_ADDHANDLER, "");
		handlerSignatures[3] = new Signature(new String[]{"String"}, CMD_REMOVEHANDLER, "");
		handlerSignatures[4] = new Signature(new String[]{"String"}, CMD_REMOVEINVOKATOR, "");
		handlerSignatures[5] = new Signature(new String[]{"String"}, CMD_REMOVELISTENER, "");
	}
	
	public Signature[] getSignatures(){
		return handlerSignatures;
	}
	
	public void handle(HgraphEvent event) {
		if(event.getCommand().equals(CMD_ADDLISTENER) && (event.getValue().getValue() instanceof Listener)){
			node.getFuncFunc().addListener((Listener)event.getValue().getValue(), event.getFromPath());
		}else if(event.getCommand().equals(CMD_ADDHANDLER) && (event.getValue().getValue() instanceof Handler)){
			node.getFuncFunc().addHandler((Handler)event.getValue().getValue(), event.getFromPath());
		}else if(event.getCommand().equals(CMD_ADDINVOKATOR) && (event.getValue().getValue() instanceof Invokator)){
			node.getFuncFunc().addInvokator((Invokator)event.getValue().getValue(), event.getFromPath());
		}else if(event.getCommand().equals(CMD_REMOVEINVOKATOR) && (event.getValue().getValue() instanceof String)){
			node.getFuncFunc().removeInvokator((String)event.getValue().getValue(), event.getFromPath());
		}else if(event.getCommand().equals(CMD_REMOVELISTENER) && (event.getValue().getValue() instanceof String)){
			node.getFuncFunc().removeListener((String)event.getValue().getValue(), event.getFromPath());
		}else if(event.getCommand().equals(CMD_REMOVEHANDLER) && (event.getValue().getValue() instanceof String)){
		node.getFuncFunc().removeHandler((String)event.getValue().getValue(), event.getFromPath());
		}

	}
}
