package ist.palcom.hgraph;

/**
 * Generic invokator class, which by default is installed on all nodes.
 */
public class GenericInvokator extends AbstractInvokator{

	private final static String name = "Generic Invokator";	
	private final static String description = "Generic functional entry point for invoking remote handlers in the h-graph";
	
	public GenericInvokator(IHgraphNode node){
		super(node, name, description);
	}

	/**
	 * 
	 * @param numLogs The number of events to log
	 * @param node
	 */
	public GenericInvokator(int numLogs, IHgraphNode node){
		super(numLogs, node, name, description);
	}
	
	public void invoke(String command, Path path){
		invoke(command, path, null, null);
	}

	public void invoke(String command, Path path, Value value){
		invoke(command, path, null, value);
	}

	public void invoke(String command, Path path, String returnCommand){
		invoke(command, path, returnCommand, null);
	}	
}
