package ist.palcom.hgraph.manager;

import ist.palcom.hgraph.AbstractHandler;
import ist.palcom.hgraph.HgraphEvent;
import ist.palcom.hgraph.Signature;
import ist.palcom.hgraph.Value;

public class LiveViewHandler extends AbstractHandler{

	public static final String CMD_LIVE_VIEW_EVENT = "cmd_live_view_event";
	
	public static final String name = "live view handler";
	public static final String description = "handles live view events";

	private Signature[] handlerSignatures;
	private LiveViewCallback callback;
	
	public LiveViewHandler(LiveViewCallback callback){
		super(name, description);
		this.callback = callback;
		handlerSignatures = new Signature[1];
		handlerSignatures[0] = new Signature(new String[]{}, CMD_LIVE_VIEW_EVENT, "Value");
	}
	
	
	public void handle(HgraphEvent event) {
		if(event.getCommand().equals(CMD_LIVE_VIEW_EVENT)){
			callback.liveViewCallback(event.getFromPath(), event.getValue().getName(), (Value)event.getValue().getValue());
		}
	}
	public Signature[] getSignatures() {
		return handlerSignatures;
	}	
}
