/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package ist.palcom.hmap;

import ist.palcom.palcomthreads.Event;


public class HmapEvent extends Event{
	
	private HmapPath fromPath = null;
	private HmapPath toPath = null;
	private String command = null;
	private HmapNode parameters = null;
	private int pid = -1;
	
	public HmapEvent(HmapPath fromPath, HmapPath toPath, String command, HmapNode parameters){
		this.fromPath = fromPath;
		this.toPath = toPath;
		this.command = command;
		this.parameters = parameters;
	}
	
	public HmapPath getFromPath(){
		return fromPath;
	}
	public HmapPath getToPath(){
		return toPath;
	}
	public String getCommand(){
		return command;
	}
	public HmapNode getParameters(){
		return parameters;
	}
	public void setFromPath(HmapPath fromPath){
		this.fromPath = fromPath;
	}
	public void setToPath(HmapPath toPath){
		this.toPath = toPath;
	}
	public void setCommand(String command){
		this.command = command;
	}
	public void setParameters(HmapNode parameters){
		this.parameters = parameters;
	}
	public void setPid(int pid){
		this.pid = pid;
	}
	public int getPid(){
		return pid;
	}
	public boolean equals(int pid){
		return this.pid == pid;
	}
	
	public String toString(){
		String tmp = "HmapEvent:"+"\n"+
				     "   Sent from: "+fromPath.toString()+"\n"+
					 "   Sent to: "+toPath.toString()+"\n"+
					 "   Command: "+command+"\n";
		if(parameters != null){
			tmp +=  "   Parameters: \n   -------\n"+
					parameters.toString()+"\n"+
					"   -------\n";
		}
		return tmp;
	}	
}
