/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package ist.palcom.jtst;

import java.util.ArrayList;
import java.util.AbstractList;
import java.util.List;

public class ConstructorTest extends Test {
  public int integer;
  public int integer1 = 1;
  protected int pinteger;
  protected int pinteger1 = 1;
  private int sinteger;
  private int sinteger1 = 1;

  public boolean bool;
  public boolean bool1 = true;
  protected boolean pbool;
  protected boolean pbool1 = true;
  private boolean sbool;
  private boolean sbool1 = true;

  public Object obj;
  public Object obj1 = new Object();
  protected Object pobj;
  protected Object pobj1 = new Object();
  private Object sobj;
  private Object sobj1 = new Object();

  public int shadowInt;
  public int shadowInt1 = 1;
  protected int pshadowInt;
  protected int pshadowInt1 = 1;
  private int sshadowInt;
  protected int sshadowInt1 = 1;

  final private int x1 = 1;
  final private static int s1 = 1;

  public String name() { return "Constructor"; }
  public void run() {
    run1();
  }

  private void run1() {
    startLine();
    print(A);

    if (integer == 0 && shadowInt == 0)
      print(B);
    if (integer1 == 1 && shadowInt1 == 1)
      print(C);

    if (pinteger == 0 && pshadowInt == 0)
      print(D);
    if (pinteger1 == 1 && pshadowInt1 == 1)
      print(E);

    if (sinteger == 0 && sshadowInt == 0)
      print(F);
    if (sinteger1 == 1 && sshadowInt1 == 1)
      print(G);

    if (bool == false)
      print(H);
    if (bool1 == true)
      print(I);

    if (pbool == false)
      print(J);
    if (pbool1 == true)
      print(K);

    if (sbool == false)
      print(L);
    if (sbool1 == true)
      print(M);

    if (obj == null)
      print(N);
    if (obj1 != null)
      print(O);

    if (pobj == null)
      print(P);
    if (pobj1 != null)
      print(Q);

    if (sobj == null)
      print(R);
    if (sobj1 != null)
      print(S);

    new Sub38().run();

    println("");

  }

  static public void mungeShadows(ConstructorTest c) {
    c.shadowInt = c.shadowInt1 = c.pshadowInt = c.pshadowInt1 = c.sshadowInt = c.sshadowInt1 = 42;
  }

  // The subclass name is chosen so that firstbyte(sha1hash("ist.palcom.jtst.ConstructorTest")) == firstbyte(sha1hash("ist.palcom.jtst.ConstructorTest$Sub38"))
  // This exposes an error in a Pal-J modification I was considering   --EC
  private static class Sub38 extends ConstructorTest {

    public int shadowInt = 1;
    public int shadowInt1 = 0;
    protected int pshadowInt = 1;
    protected int pshadowInt1 = 0;
    private int sshadowInt = 1;
    private int sshadowInt1 = 0;

    public void run() {

      mungeShadows(this); 

      if (integer == 0)
        print(T);
      if (integer1 == 1)
        print(U);

      if (pinteger == 0)
        print(V);
      if (pinteger1 == 1)
        print(W);

      if (bool == false)
        print(X);
      if (bool1 == true)
        print(Y);

      if (pbool == false)
        print(Z);
      if (pbool1 == true)
        print(0);

      if (obj == null)
        print(1);
      if (obj1 != null)
        print(2);

      if (pobj == null)
        print(3);
      if (pobj1 != null)
        print(4);

      if (shadowInt == 1)
        print(5);
      if (shadowInt1 == 0)
        print(6);

      if (pshadowInt == 1)
        print(7);
      if (pshadowInt1 == 0)
        print(8);

      if (sshadowInt == 1)
        print(9);
      if (sshadowInt1 == 0)
        print(".");
    }
  }
}
