/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public abstract class AbstractResourceAddress extends Info implements Cloneable {
    public void flushCache() {
        super.flushCache();
        tryGetLocalSID_visited = false;
        getDeviceAddress_visited = false;
        matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
    }
    public Object clone() throws CloneNotSupportedException {
        AbstractResourceAddress node = (AbstractResourceAddress)super.clone();
        node.tryGetLocalSID_visited = false;
        node.getDeviceAddress_visited = false;
        node.matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
    return node;
    }
    // Declared in HLAAddress.jadd at line 9

	
	public AbstractResourceAddress validate(ResourceAddressingManager m) {
		return m.validateAddress(this);
	}

    // Declared in HighLevelResourceInfo.ast at line 3
    // Declared in HighLevelResourceInfo.ast line 39

    public AbstractResourceAddress() {
        super();


    }

    // Declared in HighLevelResourceInfo.ast at line 9


  protected int numChildren() {
    return 0;
  }

    protected boolean tryGetLocalSID_visited = false;
    // Declared in LocalSID.jadd at line 20
    public LocalSID tryGetLocalSID() {
        if(tryGetLocalSID_visited)
            throw new RuntimeException("Circular definition of attr: tryGetLocalSID in class: ");
        tryGetLocalSID_visited = true;
        LocalSID tryGetLocalSID_value = tryGetLocalSID_compute();
        tryGetLocalSID_visited = false;
        return tryGetLocalSID_value;
    }

    private LocalSID tryGetLocalSID_compute() {  return  null;  }

    protected boolean getDeviceAddress_visited = false;
    // Declared in Address.jadd at line 33
    public DeviceAddress getDeviceAddress() {
        if(getDeviceAddress_visited)
            throw new RuntimeException("Circular definition of attr: getDeviceAddress in class: ");
        getDeviceAddress_visited = true;
        DeviceAddress getDeviceAddress_value = getDeviceAddress_compute();
        getDeviceAddress_visited = false;
        return getDeviceAddress_value;
    }

    private DeviceAddress getDeviceAddress_compute()  {
		System.err.println("***************************************");
		System.err.println("Warning! AbstractResourceAddress.getDeviceAddress() should be overrridden in "+getClass().getName());
		return null;
	}

    protected java.util.Set matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
    // Declared in Comparison.jadd at line 97
    public boolean matchesLocalSID(LocalSID l) {
        Object _parameters = l;
        if(matchesLocalSID_LocalSID_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesLocalSID in class: ");
        matchesLocalSID_LocalSID_visited.add(_parameters);
        boolean matchesLocalSID_LocalSID_value = matchesLocalSID_compute(l);
        matchesLocalSID_LocalSID_visited.remove(_parameters);
        return matchesLocalSID_LocalSID_value;
    }

    private boolean matchesLocalSID_compute(LocalSID l) {  return  false;  }

}
