/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public abstract class AbstractServiceDecl extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        lookupService_Identifier_visited = new java.util.HashSet(4);
        getErrorList_visited = false;
        getLocalName_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        AbstractServiceDecl node = (AbstractServiceDecl)super.clone();
        node.lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        node.lookupService_Identifier_visited = new java.util.HashSet(4);
        node.getErrorList_visited = false;
        node.getLocalName_visited = false;
    return node;
    }
    // Declared in AltService.jadd at line 50

    
    public void writeXMLElementBody(KXmlSerializer serializer) throws IOException{}

    // Declared in AltService.jadd at line 62


   
//    public void SingleServiceDecl.writeXMLElement(KXmlSerializer serializer)
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
//        serializer.attribute(null, "serviceName", getServiceName());
        writeXMLElementBody(serializer);
        serializer.endTag(null, getTagName());
    }

    // Declared in AltService.jadd at line 165

    
    public abstract void listenForDiscovery(ResourceAddressingManager man, PalcomThread t, boolean active);

    // Declared in HLAAddress.jadd at line 17

	
	public void validateAddress(ResourceAddressingManager m) {
		System.err.println("WARNING: AbstractServiceDecl.validateAddress should be overridden in "+getClass().getName());
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 53

    public AbstractServiceDecl() {
        super();


    }

    // Declared in Assembly.ast at line 9


  protected int numChildren() {
    return 0;
  }

    // Declared in AltService.jadd at line 139
    public abstract boolean isAlternative();
    // Declared in AssemblyNameAnalysis.jrag at line 119
    public abstract ServiceAddress getServiceAddr();
    protected java.util.Set lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 142
    public AbstractServiceDecl lookupService(AbstractResourceAddress sa) {
        Object _parameters = sa;
        if(lookupService_AbstractResourceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_AbstractResourceAddress_visited.add(_parameters);
        AbstractServiceDecl lookupService_AbstractResourceAddress_value = lookupService_compute(sa);
        lookupService_AbstractResourceAddress_visited.remove(_parameters);
        return lookupService_AbstractResourceAddress_value;
    }

    private AbstractServiceDecl lookupService_compute(AbstractResourceAddress sa)  {
    	System.out.println("AbstractServiceDecl.lookup("+sa+") not implemented");
    	return null;
    }

    protected java.util.Set lookupService_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 202
    public AbstractServiceDecl lookupService(Identifier id) {
        Object _parameters = id;
        if(lookupService_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_Identifier_visited.add(_parameters);
        AbstractServiceDecl lookupService_Identifier_value = lookupService_compute(id);
        lookupService_Identifier_visited.remove(_parameters);
        return lookupService_Identifier_value;
    }

    private AbstractServiceDecl lookupService_compute(Identifier id)  {
    	 System.out.println("AbstractServiceDecl.lookupService(Identifier) not implemented");
    	 return null;
     }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 68
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute()  {
		System.out.println("AbstractServiceDecl.getErrorList not implemented");
		return new ArrayList();
	}

    protected boolean getLocalName_visited = false;
    // Declared in AltService.jadd at line 42
    public Identifier getLocalName() {
        if(getLocalName_visited)
            throw new RuntimeException("Circular definition of attr: getLocalName in class: ");
        getLocalName_visited = true;
        Identifier getLocalName_value = getParent().Define_Identifier_getLocalName(this, null);
        getLocalName_visited = false;
        return getLocalName_value;
    }

}
