/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class AltServiceDecl extends SingleServiceDecl implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getPriority_visited = false;
        getAssemblyLabel_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        AltServiceDecl node = (AltServiceDecl)super.clone();
        node.getPriority_visited = false;
        node.getAssemblyLabel_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          AltServiceDecl node = (AltServiceDecl)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        AltServiceDecl res = (AltServiceDecl)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AltService.jadd at line 113

    

    public String getTagName() {
    	return "AltServiceDecl";
    }

    // Declared in AltService.jadd at line 116

    public void writeXMLElementBody(KXmlSerializer serializer) throws IOException{
    	String ps = getPrio();
    	if(ps == null) ps = "17";
        serializer.attribute(null, "priority", ps);
    	super.writeXMLElementBody(serializer);
    }

    // Declared in AltService.jadd at line 133

    
//    public void AltServiceDecl.writeXMLElement(KXmlSerializer serializer)
//    throws IOException {
//        serializer.startTag(null, getTagName());
////        serializer.attribute(null, "serviceName", getServiceName());
//        getLocalName().writeXMLElement(serializer);
//        getServiceName().writeXMLElement(serializer);
//        getDeviceUse().writeXMLElement(serializer);
//        serializer.endTag(null, getTagName());
//    }
    
    public void initializeFromElement(XmlPullParser parser) {
	    //setServiceName(parser.getAttributeValue(null, "serviceName"));
	    setPrio(parser.getAttributeValue(null, "priority"));
	    super.initializeFromElement(parser);
    }

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 56

    public AltServiceDecl() {
        super();

        setChild(null, 0);
        setChild(null, 1);
        setChild(null, 2);

    }

    // Declared in Assembly.ast at line 13


    // Declared in Assembly.ast line 56
    public AltServiceDecl(Identifier p0, DeviceUse p1, ServiceAddress p2, String p3) {
        setChild(p0, 0);
        setChild(p1, 1);
        setChild(p2, 2);
        setPrio(p3);
    }

    // Declared in Assembly.ast at line 20


  protected int numChildren() {
    return 3;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 54
    public void setServiceName(Identifier node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public Identifier getServiceName() {
        return (Identifier)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public Identifier getServiceNameNoTransform() {
        return (Identifier)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 54
    public void setDeviceUse(DeviceUse node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public DeviceUse getDeviceUse() {
        return (DeviceUse)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public DeviceUse getDeviceUseNoTransform() {
        return (DeviceUse)getChildNoTransform(1);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 54
    public void setServiceAddress(ServiceAddress node) {
        setChild(node, 2);
    }

    // Declared in Assembly.ast at line 5

    public ServiceAddress getServiceAddress() {
        return (ServiceAddress)getChild(2);
    }

    // Declared in Assembly.ast at line 9


    public ServiceAddress getServiceAddressNoTransform() {
        return (ServiceAddress)getChildNoTransform(2);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 56
    private String tokenString_Prio;

    // Declared in Assembly.ast at line 3

    public void setPrio(String value) {
        tokenString_Prio = value;
    }

    // Declared in Assembly.ast at line 6

    public String getPrio() {
        return tokenString_Prio;
    }

    protected boolean getPriority_visited = false;
    // Declared in AltService.jadd at line 148
    public int getPriority() {
        if(getPriority_visited)
            throw new RuntimeException("Circular definition of attr: getPriority in class: ");
        getPriority_visited = true;
        int getPriority_value = getPriority_compute();
        getPriority_visited = false;
        return getPriority_value;
    }

    private int getPriority_compute() {  return  Integer.parseInt(getPrio());  }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 171
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  super.getAssemblyLabel() + " [ priority "+getPriority()+"]";  }

}
