/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class AltServiceDeclList extends AbstractServiceDecl implements Cloneable {
    public void flushCache() {
        super.flushCache();
        isAlternative_visited = false;
        getServiceAddr_visited = false;
        lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        lookupService_Identifier_visited = new java.util.HashSet(4);
        getAssemblyLabel_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        AltServiceDeclList node = (AltServiceDeclList)super.clone();
        node.isAlternative_visited = false;
        node.getServiceAddr_visited = false;
        node.lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        node.lookupService_Identifier_visited = new java.util.HashSet(4);
        node.getAssemblyLabel_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          AltServiceDeclList node = (AltServiceDeclList)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        AltServiceDeclList res = (AltServiceDeclList)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AltService.jadd at line 92


    public String getTagName() {
    	return "AltServiceDeclList";
    }

    // Declared in AltService.jadd at line 96

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        for (int i = 0; i < getNumServiceDecl(); i++) {
            getServiceDecl(i).writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in AltService.jadd at line 105

    
    public void initializeFromElement(XmlPullParser parser) {
    }

    // Declared in AltService.jadd at line 108

        
    public void addChildFromXMLElement(XMLRepresentable child) {
        addServiceDecl((AltServiceDecl) child);
    }

    // Declared in AltService.jadd at line 185

    
    public void listenForDiscovery(ResourceAddressingManager man, PalcomThread t, boolean active) {
       	for(int i=0; i<getNumServiceDecl(); i++) {
    		getServiceDecl(i).listenForDiscovery(man, t, active);
    	}
    }

    // Declared in Resources.jadd at line 37

	public ArrayList getChildrenInPriorityOrder() {
		ArrayList l = new ArrayList();
		if(getNumServiceDecl() > 0) {
			l.add(getServiceDecl(0));
		}
		for(int i=1; i<getNumServiceDecl(); i++) {
			AltServiceDecl asd = getServiceDecl(i);
			boolean add = true;
			for (Iterator iter = l.iterator(); add&&iter.hasNext();) {
				AltServiceDecl tmp = (AltServiceDecl) iter.next();
				if(asd.getPriority() < tmp.getPriority()) {
					l.add(l.indexOf(tmp), asd);
					add=false;
				}
			}
			if(add) {
				l.add(asd);
			}
		}
//		System.out.println("GetChildrenInPriorityOrder:");
//		for (Iterator iter = l.iterator(); iter.hasNext();) {
//			AltServiceDecl asd = (AltServiceDecl) iter.next();
//			System.out.println(asd);
//		}
		
		return l;
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 55

    public AltServiceDeclList() {
        super();

        setChild(new List(), 0);

    }

    // Declared in Assembly.ast at line 11


    // Declared in Assembly.ast line 55
    public AltServiceDeclList(List p0) {
        setChild(p0, 0);
    }

    // Declared in Assembly.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 55
    public void setServiceDeclList(List list) {
        setChild(list, 0);
    }

    // Declared in Assembly.ast at line 6


    public int getNumServiceDecl() {
        return getServiceDeclList().getNumChild();
    }

    // Declared in Assembly.ast at line 10


    public AltServiceDecl getServiceDecl(int i) {
        return (AltServiceDecl)getServiceDeclList().getChild(i);
    }

    // Declared in Assembly.ast at line 14


    public void addServiceDecl(AltServiceDecl node) {
        List list = getServiceDeclList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in Assembly.ast at line 19


    public void setServiceDecl(AltServiceDecl node, int i) {
        List list = getServiceDeclList();
        list.setChild(node, i);
    }

    // Declared in Assembly.ast at line 23

    public List getServiceDeclList() {
        return (List)getChild(0);
    }

    // Declared in Assembly.ast at line 27


    public List getServiceDeclListNoTransform() {
        return (List)getChildNoTransform(0);
    }

    protected boolean isAlternative_visited = false;
    // Declared in AltService.jadd at line 142
    public boolean isAlternative() {
        if(isAlternative_visited)
            throw new RuntimeException("Circular definition of attr: isAlternative in class: ");
        isAlternative_visited = true;
        boolean isAlternative_value = isAlternative_compute();
        isAlternative_visited = false;
        return isAlternative_value;
    }

    private boolean isAlternative_compute() {  return  true;  }

    protected boolean getServiceAddr_visited = false;
    // Declared in AssemblyNameAnalysis.jrag at line 120
    public ServiceAddress getServiceAddr() {
        if(getServiceAddr_visited)
            throw new RuntimeException("Circular definition of attr: getServiceAddr in class: ");
        getServiceAddr_visited = true;
        ServiceAddress getServiceAddr_value = getServiceAddr_compute();
        getServiceAddr_visited = false;
        return getServiceAddr_value;
    }

    private ServiceAddress getServiceAddr_compute()  {
    	System.err.println("AltServiceDeclList: getServiceAddress() not applicable!");
    	return new ServiceAddress();
    }

    protected java.util.Set lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 146
    public AbstractServiceDecl lookupService(AbstractResourceAddress sa) {
        Object _parameters = sa;
        if(lookupService_AbstractResourceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_AbstractResourceAddress_visited.add(_parameters);
        AbstractServiceDecl lookupService_AbstractResourceAddress_value = lookupService_compute(sa);
        lookupService_AbstractResourceAddress_visited.remove(_parameters);
        return lookupService_AbstractResourceAddress_value;
    }

    private AbstractServiceDecl lookupService_compute(AbstractResourceAddress sa)  {
    	for(int i = 0; i<getNumServiceDecl(); i++) {
    		AbstractServiceDecl d = getServiceDecl(i).lookupService(sa);
    		if(d != null)
    			return d;
    	}
    	return null;
    }

    protected java.util.Set lookupService_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 207
    public AbstractServiceDecl lookupService(Identifier id) {
        Object _parameters = id;
        if(lookupService_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_Identifier_visited.add(_parameters);
        AbstractServiceDecl lookupService_Identifier_value = lookupService_compute(id);
        lookupService_Identifier_visited.remove(_parameters);
        return lookupService_Identifier_value;
    }

    private AbstractServiceDecl lookupService_compute(Identifier id)  {
    	 for(int i = 0; i<getNumServiceDecl(); i++) {
    		 AbstractServiceDecl d = getServiceDecl(i).lookupService(id);
    		 if(d != null)
    			 return d;
    	 }
    	 return null;
     }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 170
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  "Alternative declarations";  }

}
