/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class AssignAction extends Action implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getErrorList_visited = false;
        getAssemblyLabel_visited = false;
        ci_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        AssignAction node = (AssignAction)super.clone();
        node.getErrorList_visited = false;
        node.getAssemblyLabel_visited = false;
        node.ci_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          AssignAction node = (AssignAction)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        AssignAction res = (AssignAction)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyXML.jadd at line 517

	
	public String getTagName() {
		return "AssignAction";
	}

    // Declared in AssemblyXML.jadd at line 521


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        serializer.attribute(null, "variableUse", getVariableUse().getName());                
        serializer.attribute(null, "paramUse", getParamUse().getName());
        serializer.endTag(null, getTagName());
	}

    // Declared in AssemblyXML.jadd at line 528


	public void initializeFromElement(XmlPullParser parser) {
	    setVariableUse(new VariableUse(parser.getAttributeValue(null, "variableUse")));
        setParamUse(new ParamUse(parser.getAttributeValue(null, "paramUse")));
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 83

    public AssignAction() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in Assembly.ast at line 12


    // Declared in Assembly.ast line 83
    public AssignAction(VariableUse p0, ParamUse p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in Assembly.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 83
    public void setVariableUse(VariableUse node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public VariableUse getVariableUse() {
        return (VariableUse)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public VariableUse getVariableUseNoTransform() {
        return (VariableUse)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 83
    public void setParamUse(ParamUse node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public ParamUse getParamUse() {
        return (ParamUse)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public ParamUse getParamUseNoTransform() {
        return (ParamUse)getChildNoTransform(1);
    }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 132
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute()  {
		ArrayList l = new ArrayList();
		VariableDecl v = getVariableUse().getDecl();
		if(v == null) {
			l.add(new SemanticError(SemanticError.TYPE_ERROR, getVariableUse().getName() + " undeclared", this));			
		}

		if( ci() != null) {
			ParamInfo p = getParamUse().getDecl();
			if(p == null) {
				l.add(l.size(),new SemanticError(SemanticError.TYPE_ERROR, getParamUse().getName() + " undeclared", this));							
			}
			if(getParamUse().typeError()) {
				l.add(l.size(),new SemanticError(SemanticError.TYPE_WARNING,"Type mismatch: "+getParamUse().actualType()+" != "+getParamUse().expectedType(), this));				
			}
//			if(v != null && p != null && !(v.getType().equals(p.getType())) ) {
//				l.add(new SemanticError(SemanticError.TYPE_WARNING,"Type mismatch in "+getVariableUse().getName() + " = " +getParamUse().getName(), this));
//			}
		} else {
			l.add(l.size(),new SemanticError(SemanticError.TYPE_DONT_CARE,"[No CommandInfo] no type information for "+getVariableUse().getName() + " = " +getParamUse().getName(), this));			
		}
		return l;
	}

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 199
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getVariableUse().getAssemblyLabel() + " = "+getParamUse().getAssemblyLabel();  }

    protected boolean ci_visited = false;
    // Declared in ErrorChecking.jrag at line 112
    public CommandInfo ci() {
        if(ci_visited)
            throw new RuntimeException("Circular definition of attr: ci in class: ");
        ci_visited = true;
        CommandInfo ci_value = getParent().Define_CommandInfo_ci(this, null);
        ci_visited = false;
        return ci_value;
    }

    // Declared in AssemblyTypeAnalysis.jrag at line 64
    public String Define_String_expectedType(ASTNode caller, ASTNode child) {
        if(caller == getParamUseNoTransform()) {
	if(ci() != null) {
		VariableDecl vd = getVariableUse().getDecl();
		if(vd!=null) {
			return vd.getType();
		}
	}
	return "unknown";
}
        return getParent().Define_String_expectedType(this, caller);
    }

}
