/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class Connection extends NetworkNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getCustomer_visited = false;
        getProvider_visited = false;
        getBrowserLabel_visited = false;
        inhCust_Connection_visited = new java.util.HashSet(4);
        inhProv_Connection_visited = new java.util.HashSet(4);
    }
    public Object clone() throws CloneNotSupportedException {
        Connection node = (Connection)super.clone();
        node.getCustomer_visited = false;
        node.getProvider_visited = false;
        node.getBrowserLabel_visited = false;
        node.inhCust_Connection_visited = new java.util.HashSet(4);
        node.inhProv_Connection_visited = new java.util.HashSet(4);
    return node;
    }
    public ASTNode copy() {
      try {
          Connection node = (Connection)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        Connection res = (Connection)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 177


/* A Connection is aware of its view */
	
	private Object myView;

    // Declared in DeviceTree.jadd at line 179

	
	public void setView(Object v) {
		myView = v;
	}

    // Declared in DeviceTree.jadd at line 183

	
	public Object getView() {
		return myView;
	}

    // Declared in DeviceTree.jadd at line 348

	
	public Object[] getChildArray() {
//		return new Object[] {getInfo(), getProvider(), getCustomer()};
//		return new Object[] {getProvider().getInfo().getContentType(),getProvider(), getCustomer()};
		// Handle the case when provider or customer are not available. E.g., if a device
		// or service with active connections has been stopped
		if( getProvider() != null && getCustomer() != null)
			//XXX Do we need a replacement for content type?
			return new Object[] {getProvider(), getCustomer()};
		else
			return null;
	}

    // Declared in DeviceTree.jadd at line 372

	
	public String toString() {
		return getInfo().toString();
	}

    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 52

    public Connection() {
        super();

        setChild(null, 0);

    }

    // Declared in LocalView.ast at line 11


    // Declared in LocalView.ast line 52
    public Connection(ConnectionInfo p0) {
        setChild(p0, 0);
    }

    // Declared in LocalView.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 52
    public void setInfo(ConnectionInfo node) {
        setChild(node, 0);
    }

    // Declared in LocalView.ast at line 5

    public ConnectionInfo getInfo() {
        return (ConnectionInfo)getChild(0);
    }

    // Declared in LocalView.ast at line 9


    public ConnectionInfo getInfoNoTransform() {
        return (ConnectionInfo)getChildNoTransform(0);
    }

    protected boolean getCustomer_visited = false;
    // Declared in DeviceTree.jadd at line 101
    public Service getCustomer() {
        if(getCustomer_visited)
            throw new RuntimeException("Circular definition of attr: getCustomer in class: ");
        getCustomer_visited = true;
        Service getCustomer_value = getCustomer_compute();
        getCustomer_visited = false;
        return getCustomer_value;
    }

    private Service getCustomer_compute() {  return  inhCust(this);  }

    protected boolean getProvider_visited = false;
    // Declared in DeviceTree.jadd at line 108
    public Service getProvider() {
        if(getProvider_visited)
            throw new RuntimeException("Circular definition of attr: getProvider in class: ");
        getProvider_visited = true;
        Service getProvider_value = getProvider_compute();
        getProvider_visited = false;
        return getProvider_value;
    }

    private Service getProvider_compute() {  return  inhProv(this);  }

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 132
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute()  {
		//ConnectionInfo ci = ((Connection) obj).getInfo();
		//return ci.getProviderURN() + "-->" + ci.getCustomerURN();
		try {
			if(getProvider() != null && getCustomer() != null) {
				String provD = getProvider().parentDevice().getName();
				String provName = getProvider().getName();
				String custD = getCustomer().parentDevice().getName();
				String custName = getCustomer().getName(); 
				return  provD + "/" + provName + " --> " + custD + "/" + custName ;
			} else {
				return "Stale connection";
			}
		} catch (Throwable t) {
			return "Warning: "+t.getMessage();
		}
	}

    protected java.util.Set inhCust_Connection_visited = new java.util.HashSet(4);
    // Declared in DeviceTree.jadd at line 100
    public Service inhCust(Connection c) {
        Object _parameters = c;
        if(inhCust_Connection_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: inhCust in class: ");
        inhCust_Connection_visited.add(_parameters);
        Service inhCust_Connection_value = getParent().Define_Service_inhCust(this, null, c);
        inhCust_Connection_visited.remove(_parameters);
        return inhCust_Connection_value;
    }

    protected java.util.Set inhProv_Connection_visited = new java.util.HashSet(4);
    // Declared in DeviceTree.jadd at line 107
    public Service inhProv(Connection c) {
        Object _parameters = c;
        if(inhProv_Connection_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: inhProv in class: ");
        inhProv_Connection_visited.add(_parameters);
        Service inhProv_Connection_value = getParent().Define_Service_inhProv(this, null, c);
        inhProv_Connection_visited.remove(_parameters);
        return inhProv_Connection_value;
    }

}
