/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ConnectionDeclList extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
        lookupConnections_ServiceExp_visited = new java.util.HashSet(4);
        getAssemblyLabel_visited = false;
        encloseInBraces_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ConnectionDeclList node = (ConnectionDeclList)super.clone();
        node.lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
        node.lookupConnections_ServiceExp_visited = new java.util.HashSet(4);
        node.getAssemblyLabel_visited = false;
        node.encloseInBraces_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ConnectionDeclList node = (ConnectionDeclList)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ConnectionDeclList res = (ConnectionDeclList)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyTree.jadd at line 98


	public Object[] getChildArray() {
		return getConnectionDeclList().getChildArray();
//		return new Object[] {"ConnectionInfoList"};
	}

    // Declared in AssemblyXML.jadd at line 173


    public String getTagName() {
    	return "ConnectionDeclList";
    }

    // Declared in AssemblyXML.jadd at line 177

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        for (int i = 0; i < getNumConnectionDecl(); i++) {
            getConnectionDecl(i).writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in AssemblyXML.jadd at line 186

    
    public void initializeFromElement(XmlPullParser parser) {
    }

    // Declared in AssemblyXML.jadd at line 189

        
    public void addChildFromXMLElement(XMLRepresentable child) {
        addConnectionDecl((ConnectionDecl) child);
    }

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 45

    public ConnectionDeclList() {
        super();

        setChild(new List(), 0);

    }

    // Declared in Assembly.ast at line 11


    // Declared in Assembly.ast line 45
    public ConnectionDeclList(List p0) {
        setChild(p0, 0);
    }

    // Declared in Assembly.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 45
    public void setConnectionDeclList(List list) {
        setChild(list, 0);
    }

    // Declared in Assembly.ast at line 6


    public int getNumConnectionDecl() {
        return getConnectionDeclList().getNumChild();
    }

    // Declared in Assembly.ast at line 10


    public ConnectionDecl getConnectionDecl(int i) {
        return (ConnectionDecl)getConnectionDeclList().getChild(i);
    }

    // Declared in Assembly.ast at line 14


    public void addConnectionDecl(ConnectionDecl node) {
        List list = getConnectionDeclList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in Assembly.ast at line 19


    public void setConnectionDecl(ConnectionDecl node, int i) {
        List list = getConnectionDeclList();
        list.setChild(node, i);
    }

    // Declared in Assembly.ast at line 23

    public List getConnectionDeclList() {
        return (List)getChild(0);
    }

    // Declared in Assembly.ast at line 27


    public List getConnectionDeclListNoTransform() {
        return (List)getChildNoTransform(0);
    }

    protected java.util.Set lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 318
    public ConnectionDecl lookupConnection(ServiceExp cust, ServiceExp prov) {
        java.util.List _parameters = new java.util.ArrayList(2);
        _parameters.add(cust);
        _parameters.add(prov);
        if(lookupConnection_ServiceExp_ServiceExp_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupConnection in class: ");
        lookupConnection_ServiceExp_ServiceExp_visited.add(_parameters);
        ConnectionDecl lookupConnection_ServiceExp_ServiceExp_value = lookupConnection_compute(cust, prov);
        lookupConnection_ServiceExp_ServiceExp_visited.remove(_parameters);
        return lookupConnection_ServiceExp_ServiceExp_value;
    }

    private ConnectionDecl lookupConnection_compute(ServiceExp cust, ServiceExp prov)  {
        for (int i = 0; i < getNumConnectionDecl(); i++) {
            ConnectionDecl decl = getConnectionDecl(i).lookupConnection(cust,prov);
            if (decl != null) {
                return decl;
            }
        }
        return null;
    }

    protected java.util.Set lookupConnections_ServiceExp_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 339
    public ArrayList lookupConnections(ServiceExp svc) {
        Object _parameters = svc;
        if(lookupConnections_ServiceExp_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupConnections in class: ");
        lookupConnections_ServiceExp_visited.add(_parameters);
        ArrayList lookupConnections_ServiceExp_value = lookupConnections_compute(svc);
        lookupConnections_ServiceExp_visited.remove(_parameters);
        return lookupConnections_ServiceExp_value;
    }

    private ArrayList lookupConnections_compute(ServiceExp svc)  {
    	ArrayList al = new ArrayList();
        for (int i = 0; i < getNumConnectionDecl(); i++) {
            ConnectionDecl decl = getConnectionDecl(i).lookupConnection(svc);
            if (decl != null) {
            	al.add(decl);
            }
        }
        return al;
//        ConnectionDeclList cdl = new ConnectionDeclList();
//        for (Iterator iter = al.iterator(); iter.hasNext();) {
//			ConnectionDecl d = (ConnectionDecl) iter.next();
//			cdl.addConnectionDecl(d);
//		}
//       return cdl;
    }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 172
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  "Connections";  }

    protected boolean encloseInBraces_visited = false;
    // Declared in PrettyPrint.jrag at line 70
    public boolean encloseInBraces() {
        if(encloseInBraces_visited)
            throw new RuntimeException("Circular definition of attr: encloseInBraces in class: ");
        encloseInBraces_visited = true;
        boolean encloseInBraces_value = encloseInBraces_compute();
        encloseInBraces_visited = false;
        return encloseInBraces_value;
    }

    private boolean encloseInBraces_compute() {  return  true;  }

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 65
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

}
