/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ConstantUse extends Use implements Cloneable {
    public void flushCache() {
        super.flushCache();
        isDeclared_visited = false;
        getAssemblyLabel_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ConstantUse node = (ConstantUse)super.clone();
        node.isDeclared_visited = false;
        node.getAssemblyLabel_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ConstantUse node = (ConstantUse)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ConstantUse res = (ConstantUse)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyNameEditing.jadd at line 131

	
	public boolean updateIDfromEditor(String id) {
		if(!getConstant().equals(id)) {
			setConstant(id);
			return true;
		}
		return false;
	}

    // Declared in AssemblyScript.jadd at line 55

	
	public ConstantUse(String c) {
		this(new Identifier(c));
	}

    // Declared in AssemblyScript.jadd at line 59

	
	public String getConstant() {
		return getIdentifier().getID();
	}

    // Declared in AssemblyScript.jadd at line 63

	
	public void setConstant(String c) {
		setIdentifier(new Identifier(c));
	}

    // Declared in AssemblyScript.jadd at line 67


	public byte[] getValue(CommandEvent env) {
		return getConstant().getBytes();
	}

    // Declared in AssemblyXML.jadd at line 643


	public String getTagName() {
		return "ConstantUse";
	}

    // Declared in AssemblyXML.jadd at line 647


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        serializer.attribute(null, "constant", getConstant());                        
        serializer.endTag(null, getTagName());	
	}

    // Declared in AssemblyXML.jadd at line 653


	public void initializeFromElement(XmlPullParser parser) {
		setConstant(parser.getAttributeValue(null, "constant"));		
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 92

    public ConstantUse() {
        super();

        setChild(null, 0);

    }

    // Declared in Assembly.ast at line 11


    // Declared in Assembly.ast line 92
    public ConstantUse(Identifier p0) {
        setChild(p0, 0);
    }

    // Declared in Assembly.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 92
    public void setIdentifier(Identifier node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public Identifier getIdentifier() {
        return (Identifier)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public Identifier getIdentifierNoTransform() {
        return (Identifier)getChildNoTransform(0);
    }

    protected boolean isDeclared_visited = false;
    // Declared in AssemblyNameAnalysis.jrag at line 415
    public boolean isDeclared() {
        if(isDeclared_visited)
            throw new RuntimeException("Circular definition of attr: isDeclared in class: ");
        isDeclared_visited = true;
        boolean isDeclared_value = isDeclared_compute();
        isDeclared_visited = false;
        return isDeclared_value;
    }

    private boolean isDeclared_compute() {  return  true;  }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 189
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  "'"+getConstant()+"'";  }

}
