/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class DeviceAddress extends AbstractResourceAddress implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getDeviceAddress_visited = false;
        toString_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        DeviceAddress node = (DeviceAddress)super.clone();
        node.getDeviceAddress_visited = false;
        node.toString_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          DeviceAddress node = (DeviceAddress)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        DeviceAddress res = (DeviceAddress)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Address.jadd at line 18
	
	
	public DeviceAddress(DeviceID id) {
		this(new PRDDevice(id));
	}

    // Declared in Comparison.jadd at line 37


    public boolean matches(DeviceID did) {
   		boolean result = getPRDDevice().getDeviceID().equals(did);
   		return result;
    }

    // Declared in Comparison.jadd at line 42


    public boolean matches(DeviceAddress did) {
   		boolean result = equals(did);
   		return result;
    }

    // Declared in Comparison.jadd at line 47

    
    public boolean equals(Object o) {
    	if(o instanceof DeviceAddress) {
    		boolean result = getPRDDevice().isAboutTheSameEntityAs( ((DeviceAddress) o).getPRDDevice());
//    		System.out.println("Comparing "+getPRDDevice().getDeviceID()+"\nto "+((DeviceAddress)o).getPRDDevice().getDeviceID());
 //   		System.out.println("DeviceAddress.equals: "+result);
    		return result;
    	} else if(o instanceof PRDDevice) {
    		return getPRDDevice().isAboutTheSameEntityAs((PRDDevice)o);
    	}else {
    		return false;
    	}
    }

    // Declared in HLAXML.jadd at line 15

	

	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
		getPRDDevice().getDeviceID().writeXMLElement(serializer);
	}

    // Declared in HighLevelResourceInfo.ast at line 3
    // Declared in HighLevelResourceInfo.ast line 41

    public DeviceAddress() {
        super();

        setChild(null, 0);

    }

    // Declared in HighLevelResourceInfo.ast at line 11


    // Declared in HighLevelResourceInfo.ast line 41
    public DeviceAddress(PRDDevice p0) {
        setChild(p0, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 41
    public void setPRDDevice(PRDDevice node) {
        setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public PRDDevice getPRDDevice() {
        return (PRDDevice)getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public PRDDevice getPRDDeviceNoTransform() {
        return (PRDDevice)getChildNoTransform(0);
    }

    protected boolean getDeviceAddress_visited = false;
    // Declared in Address.jadd at line 39
    public DeviceAddress getDeviceAddress() {
        if(getDeviceAddress_visited)
            throw new RuntimeException("Circular definition of attr: getDeviceAddress in class: ");
        getDeviceAddress_visited = true;
        DeviceAddress getDeviceAddress_value = getDeviceAddress_compute();
        getDeviceAddress_visited = false;
        return getDeviceAddress_value;
    }

    private DeviceAddress getDeviceAddress_compute() {  return  this;  }

    protected boolean toString_visited = false;
    // Declared in displayStrings.jadd at line 7
    public String toString() {
        if(toString_visited)
            throw new RuntimeException("Circular definition of attr: toString in class: ");
        toString_visited = true;
        String toString_value = toString_compute();
        toString_visited = false;
        return toString_value;
    }

    private String toString_compute() {  return  getPRDDevice().toString();  }

}
