/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public class EventHandlerClause extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getErrorList_visited = false;
        getAssemblyLabel_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        EventHandlerClause node = (EventHandlerClause)super.clone();
        node.getErrorList_visited = false;
        node.getAssemblyLabel_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          EventHandlerClause node = (EventHandlerClause)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        EventHandlerClause res = (EventHandlerClause)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyTree.jadd at line 136


	public Object[] getChildArray() {
		return (getNumAction() > 0 ? getActionList().getChildArray() : null);
	}

    // Declared in AssemblyXML.jadd at line 408


	public String getTagName() {
		return "EventHandlerClause";
	}

    // Declared in AssemblyXML.jadd at line 412


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
	    serializer.startTag(null, getTagName());
//	    getEventDecl().writeXMLElement(serializer);
	    serializer.attribute(null, "commandName", getCommandName());                
//        serializer.attribute(null, "senderService", getSenderService());
	    getServiceExp().writeXMLElement(serializer);
	    if(hasCommandInfo()) getCommandInfo().writeXMLElement(serializer);
	    
	    for (int i = 0; i < getNumAction(); i++) {
	    	getAction(i).writeXMLElement(serializer);
		}
        serializer.endTag(null, getTagName());	
	}

    // Declared in AssemblyXML.jadd at line 426


	public void initializeFromElement(XmlPullParser parser) {
	    setCommandName(parser.getAttributeValue(null, "commandName"));
//        setSenderService(parser.getAttributeValue(null, "senderService"));
	}

    // Declared in AssemblyXML.jadd at line 431


    public void addChildFromXMLElement(XMLRepresentable child) {
//    	if(child instanceof EventDecl)
//	        setEventDecl((EventDecl) child);
    	if(child instanceof ServiceExp)
	        setServiceExp((ServiceExp) child);
    	else if(child instanceof CommandInfo)
	    	setCommandInfo((CommandInfo)child);
    	else if(child instanceof Action)
	    	addAction((Action)child);
    }

    // Declared in PrettyPrint.jrag at line 97


   void pp(PrintStream ppStream, String indent) {
	   ppStream.println(indent+getPrettyString());
	   //getServiceExp().pp(ppStream, indent+getIndent());
	   getActionList().pp(ppStream, indent+getIndent());
   }

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 80

    public EventHandlerClause() {
        super();

        setChild(null, 0);
        setChild(new Opt(), 1);
        setChild(new List(), 2);

    }

    // Declared in Assembly.ast at line 13


    // Declared in Assembly.ast line 80
    public EventHandlerClause(String p0, ServiceExp p1, Opt p2, List p3) {
        setCommandName(p0);
        setChild(p1, 0);
        setChild(p2, 1);
        setChild(p3, 2);
    }

    // Declared in Assembly.ast at line 20


  protected int numChildren() {
    return 3;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 80
    private String tokenString_CommandName;

    // Declared in Assembly.ast at line 3

    public void setCommandName(String value) {
        tokenString_CommandName = value;
    }

    // Declared in Assembly.ast at line 6

    public String getCommandName() {
        return tokenString_CommandName;
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 80
    public void setServiceExp(ServiceExp node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public ServiceExp getServiceExp() {
        return (ServiceExp)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public ServiceExp getServiceExpNoTransform() {
        return (ServiceExp)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 80
    public void setCommandInfoOpt(Opt opt) {
        setChild(opt, 1);
    }

    // Declared in Assembly.ast at line 6


    public boolean hasCommandInfo() {
        return getCommandInfoOpt().getNumChild() != 0;
    }

    // Declared in Assembly.ast at line 10


    public CommandInfo getCommandInfo() {
        return (CommandInfo)getCommandInfoOpt().getChild(0);
    }

    // Declared in Assembly.ast at line 14


    public void setCommandInfo(CommandInfo node) {
        getCommandInfoOpt().setChild(node, 0);
    }

    // Declared in Assembly.ast at line 17

    public Opt getCommandInfoOpt() {
        return (Opt)getChild(1);
    }

    // Declared in Assembly.ast at line 21


    public Opt getCommandInfoOptNoTransform() {
        return (Opt)getChildNoTransform(1);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 80
    public void setActionList(List list) {
        setChild(list, 2);
    }

    // Declared in Assembly.ast at line 6


    public int getNumAction() {
        return getActionList().getNumChild();
    }

    // Declared in Assembly.ast at line 10


    public Action getAction(int i) {
        return (Action)getActionList().getChild(i);
    }

    // Declared in Assembly.ast at line 14


    public void addAction(Action node) {
        List list = getActionList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in Assembly.ast at line 19


    public void setAction(Action node, int i) {
        List list = getActionList();
        list.setChild(node, i);
    }

    // Declared in Assembly.ast at line 23

    public List getActionList() {
        return (List)getChild(2);
    }

    // Declared in Assembly.ast at line 27


    public List getActionListNoTransform() {
        return (List)getChildNoTransform(2);
    }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 91
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute()  {
		ArrayList l = new ArrayList();
		String prefix = "[ In handler for "+getCommandName()+"] ";
		ServiceExp se = getServiceExp();
		// Check if service can be found
		l.addAll(se.getErrorList());
		// Check if connection is declared for service
		ConnectionDecl cd = av().lookupConnection(new ThisService(), se);
		if(cd == null && ! (se instanceof ThisService)) {
			// "this" means the synthesized service --> No connection declaration required
			l.add(l.size(),new SemanticError(SemanticError.TYPE_WARNING,prefix+"No connection declared from "+getServiceExp(), this));
		}
		
		l.addAll(l.size(),getActionList().getErrorList());
		
		return l;
	}

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 194
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute()  {
		ServiceExp serviceExp = getServiceExp();
//		return "when "+getCommandName()+" from "+ai().lookupAndFormatURN(serviceExp.getURN());
		return "when "+getCommandName()+" from "+serviceExp.getAssemblyLabel();
	}

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 67
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

    // Declared in ErrorChecking.jrag at line 110
    public CommandInfo Define_CommandInfo_ci(ASTNode caller, ASTNode child) {
        if(caller == getActionListNoTransform()) {
      int childIndex = caller.getIndexOfChild(child);
            return  hasCommandInfo() ? getCommandInfo() : null;
        }
        return getParent().Define_CommandInfo_ci(this, caller);
    }

}
