/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class EventHandlerScript extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupVariable_String_visited = new java.util.HashSet(4);
        getAssemblyLabel_visited = false;
        encloseInBraces_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        EventHandlerScript node = (EventHandlerScript)super.clone();
        node.lookupVariable_String_visited = new java.util.HashSet(4);
        node.getAssemblyLabel_visited = false;
        node.encloseInBraces_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          EventHandlerScript node = (EventHandlerScript)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        EventHandlerScript res = (EventHandlerScript)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyXML.jadd at line 374

	
	public String getTagName() {
		return "EventHandlerScript";
	}

    // Declared in AssemblyXML.jadd at line 378


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        getVariables().writeXMLElement(serializer);
        getEventHandlers().writeXMLElement(serializer);
        
//      for (int i = 0; i < getVariables().getNumVariableDecl(); i++) {
//            getVariables().getVariableDecl(i).writeXMLElement(serializer);
//        }
//        for (int i = 0; i < getEventHandlers().getNumEventHandlerClause(); i++) {
//            getEventHandlers().getEventHandlerClause(i).writeXMLElement(serializer);
//        }        
        serializer.endTag(null, getTagName());
	}

    // Declared in AssemblyXML.jadd at line 392


	public void initializeFromElement(XmlPullParser parser) {
	}

    // Declared in AssemblyXML.jadd at line 395

	
	public void addChildFromXMLElement(XMLRepresentable child) {    
		if(child instanceof VariableList) 
			setVariables((VariableList) child);
		else if (child instanceof EventHandlerList)
			setEventHandlers((EventHandlerList) child);
//		if(child instanceof VariableDecl)
//			getVariables().addVariableDecl((VariableDecl)child);
//		else if (child instanceof EventDecl)
//			getEventHandlers().addEventHandlerClause(new EventHandlerClause((EventDecl) child, new List()));		
		else
			System.out.println("EventHandlerScript.addChild... :"+child);
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 46

    public EventHandlerScript() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in Assembly.ast at line 12


    // Declared in Assembly.ast line 46
    public EventHandlerScript(VariableList p0, EventHandlerList p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in Assembly.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 46
    public void setVariables(VariableList node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public VariableList getVariables() {
        return (VariableList)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public VariableList getVariablesNoTransform() {
        return (VariableList)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 46
    public void setEventHandlers(EventHandlerList node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public EventHandlerList getEventHandlers() {
        return (EventHandlerList)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public EventHandlerList getEventHandlersNoTransform() {
        return (EventHandlerList)getChildNoTransform(1);
    }

    protected java.util.Set lookupVariable_String_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 43
    public VariableDecl lookupVariable(String name) {
        Object _parameters = name;
        if(lookupVariable_String_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupVariable in class: ");
        lookupVariable_String_visited.add(_parameters);
        VariableDecl lookupVariable_String_value = lookupVariable_compute(name);
        lookupVariable_String_visited.remove(_parameters);
        return lookupVariable_String_value;
    }

    private VariableDecl lookupVariable_compute(String name)  {
        for (int i = 0; i < getVariables().getNumVariableDecl(); i++) {
            VariableDecl decl = getVariables().getVariableDecl(i).lookupVariable(name);
            if (decl != null) {
                return decl;
            }
        }
        return null;
    }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 185
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  "Script";  }

    protected boolean encloseInBraces_visited = false;
    // Declared in PrettyPrint.jrag at line 71
    public boolean encloseInBraces() {
        if(encloseInBraces_visited)
            throw new RuntimeException("Circular definition of attr: encloseInBraces in class: ");
        encloseInBraces_visited = true;
        boolean encloseInBraces_value = encloseInBraces_compute();
        encloseInBraces_visited = false;
        return encloseInBraces_value;
    }

    private boolean encloseInBraces_compute() {  return  true;  }

}
