/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class GroupInfo extends ControlInfo implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getBrowserLabel_visited = false;
        lookupCommand_String_visited = new java.util.HashSet(4);
    }
    public Object clone() throws CloneNotSupportedException {
        GroupInfo node = (GroupInfo)super.clone();
        node.getBrowserLabel_visited = false;
        node.lookupCommand_String_visited = new java.util.HashSet(4);
    return node;
    }
    public ASTNode copy() {
      try {
          GroupInfo node = (GroupInfo)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        GroupInfo res = (GroupInfo)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 291


//   public Object[] ServiceDescription.getChildArray() {
//   		System.out.println("ServiceDescription.getChildArray()");
//   		Object[] tmp = super.getChildArray();
//   		System.out.println("... returns: "+tmp);
//   		return tmp;
//   	}

	public Object[] getChildArray() {
		if(getControlInfoList() != null) {
			return getControlInfoList().getChildArray();
		} 
		return null;
	}

    // Declared in ServiceDescription.jadd at line 80


    public GroupInfo(String id) {
        super(id, null);
    
        setChild(new List(), 0);
        getChildNoTransform(0).setParent(this);
    }

    // Declared in ServiceDescription.jadd at line 640


    public ControlItem createInstance() {
        Group instance = new Group(this, new List());
        for (int i = 0; i < getNumControlInfo(); i++) {
            instance.addControlItem(getControlInfo(i).createInstance());
        }
        return instance;
    }

    // Declared in Comparison.jadd at line 252


    public boolean isAboutTheSameEntityAs(PRDData data) {
        return equals(data);
    }

    // Declared in Comparison.jadd at line 435


    public boolean equals(Object o) {
        if (!super.equals(o)) {
            return false;
        }

        if (o instanceof GroupInfo) {
            GroupInfo g = (GroupInfo) o;
            for (int i = 0; i < getNumControlInfo(); i++) {
                if (!g.getControlInfo(i).equals(getControlInfo(i))) {
                    return false;
                }
            }
            return true;
        } else {
            return false;
        }
    }

    // Declared in XML.jadd at line 116

    
    public String getTagName() {
        return "GI";
    }

    // Declared in XML.jadd at line 462

    
    public void addChildFromXMLElement(XMLRepresentable child) {
        addControlInfo((ControlInfo) child);
    }

    // Declared in XML.jadd at line 626


    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        writeStartTagAndAttributes(serializer);
        for (int i = 0; i < getNumControlInfo(); i++) {
            getControlInfo(i).writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 70

    public GroupInfo() {
        super();

        setChild(new List(), 0);

    }

    // Declared in PalcomResourceDescriptor.ast at line 11


    // Declared in PalcomResourceDescriptor.ast line 70
    public GroupInfo(String p0, String p1, List p2) {
        setID(p0);
        setHelp(p1);
        setChild(p2, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 17


  protected int numChildren() {
    return 1;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 69
    private String tokenString_ID;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void refined_PalcomResourceDescriptor_setID(String value) {
        tokenString_ID = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getID() {
        return tokenString_ID;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 69
    private String tokenString_Help;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void refined_PalcomResourceDescriptor_setHelp(String value) {
        tokenString_Help = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getHelp() {
        return tokenString_Help;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 70
    public void setControlInfoList(List list) {
        setChild(list, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 6


    public int getNumControlInfo() {
        return getControlInfoList().getNumChild();
    }

    // Declared in PalcomResourceDescriptor.ast at line 10


    public ControlInfo getControlInfo(int i) {
        return (ControlInfo)getControlInfoList().getChild(i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 14


    public void addControlInfo(ControlInfo node) {
        List list = getControlInfoList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in PalcomResourceDescriptor.ast at line 19


    public void setControlInfo(ControlInfo node, int i) {
        List list = getControlInfoList();
        list.setChild(node, i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 23

    public List getControlInfoList() {
        return (List)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 27


    public List getControlInfoListNoTransform() {
        return (List)getChildNoTransform(0);
    }

    // Declared in Hgraph.jadd at line 86

	  public void setID(String ID){
		refined_PalcomResourceDescriptor_setID(ID);
		if(ID != null){
			_node.setNodeName(getTagName() + " - " + ID, null);
		}
	}

    // Declared in Hgraph.jadd at line 104

	  public void setHelp(String help){
		refined_PalcomResourceDescriptor_setHelp(help);
		if(help != null){
			_node.setNodeName(getTagName() + " - " + help, null);
		}
	}

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 94
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute()  {
		return (getID() == null ? "GroupInfo" : getID());
	}

    protected java.util.Set lookupCommand_String_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 202
    public ControlInfo lookupCommand(String id) {
        Object _parameters = id;
        if(lookupCommand_String_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupCommand in class: ");
        lookupCommand_String_visited.add(_parameters);
        ControlInfo lookupCommand_String_value = lookupCommand_compute(id);
        lookupCommand_String_visited.remove(_parameters);
        return lookupCommand_String_value;
    }

    private ControlInfo lookupCommand_compute(String id)  {
	for(int i=0; i < getNumControlInfo(); i++) {
		ControlInfo ci = getControlInfo(i).lookupCommand(id);
		if(ci instanceof CommandInfo)
			return ci;
	}
	return null;
}

}
