/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class PRDConnectionList extends PRDSecondOrderList implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        PRDConnectionList node = (PRDConnectionList)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          PRDConnectionList node = (PRDConnectionList)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDConnectionList res = (PRDConnectionList)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Info.jadd at line 52

    
    public PRDConnectionList(DeviceID deviceID) {
    	this();
    	setDeviceID(deviceID);
    }

    // Declared in Comparison.jadd at line 225


    public boolean isAboutTheSameEntityAs(PRDData data) {
        if (data == null) {
            return false;
        } else if (data instanceof PRDConnectionList) {
            PRDConnectionList cil = (PRDConnectionList) data;
            return PRDData.safeEqual(cil.getDeviceID(), getDeviceID());
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 406


    public boolean equals(Object o) {
        if (o instanceof PRDConnectionList) {
            PRDConnectionList cil = (PRDConnectionList) o;
            if (!cil.getDeviceID().equals(getDeviceID())) {
                return false;
            }
            if (cil.getNumPRDConnection() != getNumPRDConnection()) {
                return false;
            }
            for (int i = 0; i < getNumPRDConnection(); i++) {
                if (!cil.getPRDConnection(i).equals(getPRDConnection(i))) {
                    return false;
                }
            }
            return true;
        } else {
            return false;
        }
    }

    // Declared in XML.jadd at line 101


    public String getTagName() {
        return "CL";
    }

    // Declared in XML.jadd at line 288

        
    public void initializeFromElement(XmlPullParser parser) {
    	/*String deviceID = parser.getAttributeValue(null, "did");
    	if(deviceID != null) {
        	setDeviceID(new DeviceID(deviceID));
        }*/
    }

    // Declared in XML.jadd at line 454

    
    public void addChildFromXMLElement(XMLRepresentable child) {
        if (child instanceof PRDConnection) {
            addPRDConnection((PRDConnection) child);
        } else if(child instanceof DeviceID) {
        	setDeviceID((DeviceID) child);
        }
    }

    // Declared in XML.jadd at line 616

        
    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());

        for (int i = 0; i < getNumPRDConnection(); i++) {
            getPRDConnection(i).writeXMLElement(serializer);
        }

        serializer.endTag(null, getTagName());
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 64

    public void refined_PalcomResourceDescriptor_PRDConnectionList() {

        setChild(new Opt(), 0);
        setChild(new List(), 1);

    }

    // Declared in PalcomResourceDescriptor.ast at line 12


    // Declared in PalcomResourceDescriptor.ast line 64
    public PRDConnectionList(Opt p0, List p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 64
    public void setDeviceIDOpt(Opt opt) {
        setChild(opt, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 6


    public boolean hasDeviceID() {
        return getDeviceIDOpt().getNumChild() != 0;
    }

    // Declared in PalcomResourceDescriptor.ast at line 10


    public DeviceID getDeviceID() {
        return (DeviceID)getDeviceIDOpt().getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 14


    public void setDeviceID(DeviceID node) {
        getDeviceIDOpt().setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 17

    public Opt getDeviceIDOpt() {
        return (Opt)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 21


    public Opt getDeviceIDOptNoTransform() {
        return (Opt)getChildNoTransform(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 64
    public void setPRDConnectionList(List list) {
        setChild(list, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 6


    public int getNumPRDConnection() {
        return getPRDConnectionList().getNumChild();
    }

    // Declared in PalcomResourceDescriptor.ast at line 10


    public PRDConnection getPRDConnection(int i) {
        return (PRDConnection)getPRDConnectionList().getChild(i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 14


    public void addPRDConnection(PRDConnection node) {
        List list = getPRDConnectionList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in PalcomResourceDescriptor.ast at line 19


    public void setPRDConnection(PRDConnection node, int i) {
        List list = getPRDConnectionList();
        list.setChild(node, i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 23

    public List getPRDConnectionList() {
        return (List)getChild(1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 27


    public List getPRDConnectionListNoTransform() {
        return (List)getChildNoTransform(1);
    }

    // Declared in Hgraph.jadd at line 134



	  public PRDConnectionList() {
		refined_PalcomResourceDescriptor_PRDConnectionList();
		_node.setNodeName("PRDConnectionList", null);
}


}
