/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public abstract class PRDData extends AbstractXMLRepresentable implements Cloneable,  ist.palcom.hgraph.IHgraphNode {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        PRDData node = (PRDData)super.clone();
    return node;
    }
    // Declared in Comparison.jadd at line 120

    
    /**
     * @return True if info and this info are for the same entity. This can be
        /**
     * @return True if data and this data are for the same entity. This can be
     *         true even if they are not completely identical, looking at their
     *         whole trees. The equals method for PRDDatas, on the other hand, is
     *         implemented to check for that.
     */
    public boolean isAboutTheSameEntityAs(PRDData data){
    	return false;
    }

    // Declared in Comparison.jadd at line 130


	/**
     * @return This data, if it equals data, or a contained data that equals
     *         data (i.e. contained, not only referenced by URN), or null. The
     *         implementation here just checks equals, subclasses override where
     *         needed.
     */
    public PRDData getPRDDataThatEquals(PRDData data) {
        if (equals(data)) {
            return this;
        } else {
            return null;
        }
    }

    // Declared in Comparison.jadd at line 144


    /**
     * @return This data, if it is about the same entity as data, or a contained
     *         data that is about the same entity as data (i.e. contained, not
     *         only referenced by URN), or null. The implementation here just
     *         checks isAboutTheSameEntityAs, subclasses override where needed.
     */
    public PRDData getPRDDataThatIsAboutTheSameEntityAs(PRDData data) {
        if (isAboutTheSameEntityAs(data)) {
            return this;
        } else {
            return null;
        }
    }

    // Declared in Comparison.jadd at line 152


    protected static boolean safeEqual(Object o1, Object o2) {
        if (o1 == null && o2 == null) {
            return true;
        } else if (o1 != null && o2 != null) {
            return o1.equals(o2);
        } else {
            return false;
        }
    }

    // Declared in Hgraph.jadd at line 70

	
	public void setChild(ASTNode child, int i){
		super.setChild(child, i);
		if(child != null){
			if(child instanceof PRDData){
				_node.removeNodeChild(((PRDData)child).getNodeName(), null);
				_node.addNodeChild((PRDData)child, null);			
			}
		}
	}

    // Declared in Hgraph.jadd at line 242

	protected IHgraphNode _node = new HgraphNode();

    // Declared in Hgraph.jadd at line 244


	public IHgraphNode getNodeParent(){return _node.getNodeParent();}

    // Declared in Hgraph.jadd at line 245

	public Iterator getChildIterator(){return _node.getChildIterator();}

    // Declared in Hgraph.jadd at line 246

	public String getNodeName(){return _node.getNodeName();}

    // Declared in Hgraph.jadd at line 247

	public int setNodeName(String name, Path callerPath){return _node.setNodeName(name, callerPath);}

    // Declared in Hgraph.jadd at line 248

	public Path getPath(){return _node.getPath();}

    // Declared in Hgraph.jadd at line 249

	public void updatePath(){_node.updatePath();}

    // Declared in Hgraph.jadd at line 250

	public boolean hasChildNamed(String name){return _node.hasChildNamed(name);}

    // Declared in Hgraph.jadd at line 251

	public boolean isAncestorOf(IHgraphNode node) {return _node.isAncestorOf(node);}

    // Declared in Hgraph.jadd at line 252

	public int removeNodeChild(String name, Path callerPath){return _node.removeNodeChild(name, callerPath);}

    // Declared in Hgraph.jadd at line 253

	public String toXML(){return _node.toXML();}

    // Declared in Hgraph.jadd at line 254

	public String toXMLFull(){return _node.toXMLFull();}

    // Declared in Hgraph.jadd at line 255

	public String toXMLRecursively(){return _node.toXMLRecursively();}

    // Declared in Hgraph.jadd at line 256

	public String toXMLFullRecursively(){return _node.toXMLFullRecursively();}

    // Declared in Hgraph.jadd at line 257

	public int setNodeParent(IHgraphNode newParent, Path callerPath) {return _node.setNodeParent(newParent, callerPath);}

    // Declared in Hgraph.jadd at line 258

	public int addNodeChild(IHgraphNode node, Path callerPath) {return _node.addNodeChild(node, callerPath);}

    // Declared in Hgraph.jadd at line 259
	
	public SiblingFunc getSiblingFunc(){return _node.getSiblingFunc();}

    // Declared in Hgraph.jadd at line 260

	public ValueFunc getValueFunc(){return _node.getValueFunc();}

    // Declared in Hgraph.jadd at line 261

	public FuncFunc getFuncFunc(){return _node.getFuncFunc();}

    // Declared in Info.jadd at line 46

	
	public static final byte PARTIALLY_OPERATIONAL = (byte)'Y';

    // Declared in Info.jadd at line 48

	
	public static final byte FULLY_OPERATIONAL = (byte)'G';

    // Declared in Info.jadd at line 50

	
    public static final byte NOT_OPERATIONAL = (byte)'R';

    // Declared in Info.jadd at line 58


    public String getName() {
        return null;
    }

    // Declared in Info.jadd at line 71

    
    /** @return The LocalSID of the entity described, or null if not applicable. */
    public LocalSID getLocalSID() {
        return null;
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 38

    public PRDData() {
        super();


    }

    // Declared in PalcomResourceDescriptor.ast at line 9


  protected int numChildren() {
    return 0;
  }

}
