/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


			
public class PRDSubList extends PRDServiceListItem implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getKindAsString_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        PRDSubList node = (PRDSubList)super.clone();
        node.getKindAsString_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          PRDSubList node = (PRDSubList)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDSubList res = (PRDSubList)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Comparison.jadd at line 279

    
    public boolean isAboutTheSameEntityAs(PRDData data) {
        if (data == null) {
            return false;
        } else if (data instanceof PRDSubList) {
            PRDSubList s = (PRDSubList) data;
            return PRDData.safeEqual(s.getListLocalSID(), getListLocalSID());
        } else {
            return false;
        }
    }

    // Declared in Info.jadd at line 52

	
	public static final byte KIND_ASSEMBLY = (byte) 'A';

    // Declared in Info.jadd at line 54

	
	public static final byte KIND_HIERARCHICAL = (byte) 'H';

    // Declared in Info.jadd at line 56

	
	public static final byte KIND_UNBOUND_COMPONENT = (byte) 'S';

    // Declared in Info.jadd at line 66

    
    public LocalSID getLocalSID() {
    	return getListLocalSID();
    }

    // Declared in XML.jadd at line 136

    
    public String getTagName() {
		return "SubL";
	}

    // Declared in XML.jadd at line 305

    
    public void initializeFromElement(XmlPullParser parser) {
        super.initializeFromElement(parser);
        setListLocalSID(new LocalSID(null, parser.getAttributeValue(null, "ls")));
        setKind(parser.getAttributeValue(null, "k").getBytes()[0]);
    }

    // Declared in XML.jadd at line 668

    
    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
		serializer.startTag(null, getTagName());
		super.writeAttributes(serializer);
		serializer.attribute(null, "ls", getListLocalSID().getServicePartID());
		serializer.attribute(null, "k", new String(new byte[] {getKind()}));
		serializer.endTag(null, getTagName());
	}

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 59

    public PRDSubList() {
        super();

        setChild(null, 0);

    }

    // Declared in PalcomResourceDescriptor.ast at line 11


    // Declared in PalcomResourceDescriptor.ast line 59
    public PRDSubList(String p0, LocalSID p1, byte p2) {
        setName(p0);
        setChild(p1, 0);
        setKind(p2);
    }

    // Declared in PalcomResourceDescriptor.ast at line 17


  protected int numChildren() {
    return 1;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 40
    private String tokenString_Name;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setName(String value) {
        tokenString_Name = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 59
    public void setListLocalSID(LocalSID node) {
        setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public LocalSID getListLocalSID() {
        return (LocalSID)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public LocalSID getListLocalSIDNoTransform() {
        return (LocalSID)getChildNoTransform(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 59
    private byte tokenbyte_Kind;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setKind(byte value) {
        tokenbyte_Kind = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public byte getKind() {
        return tokenbyte_Kind;
    }

    protected boolean getKindAsString_visited = false;
    // Declared in HumanReadableString.jadd at line 2
    public String getKindAsString() {
        if(getKindAsString_visited)
            throw new RuntimeException("Circular definition of attr: getKindAsString in class: ");
        getKindAsString_visited = true;
        String getKindAsString_value = getKindAsString_compute();
        getKindAsString_visited = false;
        return getKindAsString_value;
    }

    private String getKindAsString_compute()  {
		switch(getKind()) {
			case 'A':
				return "Assembly";
			case 'H':
				return "Hierarchical";
			case 'S':
				return "Unbound component";
			default:
				return "Unknown";
		}
	}

}
