/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ParamUse extends Use implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getDecl_CommandEvent_visited = new java.util.HashSet(4);
        isDeclared_visited = false;
        actualType_visited = false;
        getDecl_visited = false;
        getUseName_visited = false;
        getAssemblyLabel_visited = false;
        ci_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ParamUse node = (ParamUse)super.clone();
        node.getDecl_CommandEvent_visited = new java.util.HashSet(4);
        node.isDeclared_visited = false;
        node.actualType_visited = false;
        node.getDecl_visited = false;
        node.getUseName_visited = false;
        node.getAssemblyLabel_visited = false;
        node.ci_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ParamUse node = (ParamUse)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ParamUse res = (ParamUse)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyScript.jadd at line 46

	
	public byte[] getValue(CommandEvent env) {
		return env.getCommand().getParam(getName()).getData();
	}

    // Declared in AssemblyXML.jadd at line 603



	public String getTagName() {
		return "ParamUse";
	}

    // Declared in AssemblyXML.jadd at line 607


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        serializer.attribute(null, "name", getName());                
        serializer.endTag(null, getTagName());	
	}

    // Declared in AssemblyXML.jadd at line 613


	public void initializeFromElement(XmlPullParser parser) {
		setName(parser.getAttributeValue(null, "name"));		
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 91

    public ParamUse() {
        super();


    }

    // Declared in Assembly.ast at line 10


    // Declared in Assembly.ast line 91
    public ParamUse(String p0) {
        setName(p0);
    }

    // Declared in Assembly.ast at line 14


  protected int numChildren() {
    return 0;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 91
    private String tokenString_Name;

    // Declared in Assembly.ast at line 3

    public void setName(String value) {
        tokenString_Name = value;
    }

    // Declared in Assembly.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    protected java.util.Set getDecl_CommandEvent_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 310
    public Param getDecl(CommandEvent env) {
        Object _parameters = env;
        if(getDecl_CommandEvent_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: getDecl in class: ");
        getDecl_CommandEvent_visited.add(_parameters);
        Param getDecl_CommandEvent_value = getDecl_compute(env);
        getDecl_CommandEvent_visited.remove(_parameters);
        return getDecl_CommandEvent_value;
    }

    private Param getDecl_compute(CommandEvent env) {  return  (Param) env.getCommand().findItem(getName());  }

    protected boolean isDeclared_visited = false;
    // Declared in AssemblyNameAnalysis.jrag at line 414
    public boolean isDeclared() {
        if(isDeclared_visited)
            throw new RuntimeException("Circular definition of attr: isDeclared in class: ");
        isDeclared_visited = true;
        boolean isDeclared_value = isDeclared_compute();
        isDeclared_visited = false;
        return isDeclared_value;
    }

    private boolean isDeclared_compute() {  return  getDecl() != null;  }

    protected boolean actualType_visited = false;
    // Declared in AssemblyTypeAnalysis.jrag at line 55
    public String actualType() {
        if(actualType_visited)
            throw new RuntimeException("Circular definition of attr: actualType in class: ");
        actualType_visited = true;
        String actualType_value = actualType_compute();
        actualType_visited = false;
        return actualType_value;
    }

    private String actualType_compute()  {
	ParamInfo pi = getDecl();
	if(pi != null) {
		return pi.getType();
	}
	return "unknown";
}

    protected boolean getDecl_visited = false;
    // Declared in ErrorChecking.jrag at line 118
    public ParamInfo getDecl() {
        if(getDecl_visited)
            throw new RuntimeException("Circular definition of attr: getDecl in class: ");
        getDecl_visited = true;
        ParamInfo getDecl_value = getDecl_compute();
        getDecl_visited = false;
        return getDecl_value;
    }

    private ParamInfo getDecl_compute()  {
		if(ci() != null) {
			return ci().lookupParam(getName());
		}
		return null;
	}

    protected boolean getUseName_visited = false;
    // Declared in ErrorChecking.jrag at line 128
    public String getUseName() {
        if(getUseName_visited)
            throw new RuntimeException("Circular definition of attr: getUseName in class: ");
        getUseName_visited = true;
        String getUseName_value = getUseName_compute();
        getUseName_visited = false;
        return getUseName_value;
    }

    private String getUseName_compute() {  return  getName();  }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 190
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  "thisevent."+getName();  }

    protected boolean ci_visited = false;
    // Declared in ErrorChecking.jrag at line 114
    public CommandInfo ci() {
        if(ci_visited)
            throw new RuntimeException("Circular definition of attr: ci in class: ");
        ci_visited = true;
        CommandInfo ci_value = getParent().Define_CommandInfo_ci(this, null);
        ci_visited = false;
        return ci_value;
    }

}
