/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ServiceAddress extends AbstractResourceAddress implements Cloneable {
    public void flushCache() {
        super.flushCache();
        tryGetLocalSID_visited = false;
        getDeviceAddress_visited = false;
        matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        getName_visited = false;
        toString_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ServiceAddress node = (ServiceAddress)super.clone();
        node.tryGetLocalSID_visited = false;
        node.getDeviceAddress_visited = false;
        node.matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        node.getName_visited = false;
        node.toString_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ServiceAddress node = (ServiceAddress)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ServiceAddress res = (ServiceAddress)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Address.jadd at line 24

	
	/** Constructor without LocalSID
	*/
	public ServiceAddress(ServiceInstanceID sid, PRDService s) {
		this(sid, new Opt(s), new Opt());
	}

    // Declared in Address.jadd at line 29

	/** Constructor with LocalSID
	*/
	public ServiceAddress(ServiceInstanceID sid, PRDService s, LocalSID l) {
		this(sid, new Opt(s), new Opt(l));
	}

    // Declared in Comparison.jadd at line 60


    public boolean equals(Object o) {
    	if(o instanceof ServiceAddress) {
    	    ServiceAddress sa = (ServiceAddress) o;
//    	    if(hasLocalSID() && sa.hasLocalSID() ) {
//   	    	if(getLocalSID().equals(sa.getLocalSID())) {
//    	    		return true; 
//    	    	}
//    	    }
    	    if(getServiceInstanceID() != null && sa.getServiceInstanceID()!=null) {
    	    	return getServiceInstanceID().equals(sa.getServiceInstanceID());
    	    } else {
    	    	return false;
    	    }
//	    	return getPRDService().isAboutTheSameEntityAs( sa.getPRDService());
    	} else if (o instanceof TemporaryAddress) {
    		TemporaryAddress ta = (TemporaryAddress) o;
    		if(hasPRDService())
    			return getPRDService().getLocalSID().equals(ta.getLocalSID());
    		else if(hasLocalSID()) {
    			return getLocalSID().equals(ta.getLocalSID());
    		} else
    			return false;
    	} else {
    		return false;
    	}
    }

    // Declared in HLAXML.jadd at line 19


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
		getServiceInstanceID().writeXMLElement(serializer);
		if(hasPRDService()) {
			getPRDService().writeXMLElement(serializer);
		}
		if(hasLocalSID()) {
			getLocalSID().writeXMLElement(serializer);
		}
		serializer.endTag(null, getTagName());
	}

    // Declared in HLAXML.jadd at line 30

	public void addChildFromXMLElement(XMLRepresentable child) {
		if(child instanceof ServiceInstanceID) {
			setServiceInstanceID((ServiceInstanceID)child);
		} else if(child instanceof PRDService) {
			setPRDService((PRDService)child);
		} else if(child instanceof LocalSID) {
			setLocalSID((LocalSID) child);
		} else {
			System.err.println("WARNING! ServiceAddress.addChildFromXMLElement: unknown class: "+child.getClass());
		}
	}

    // Declared in HighLevelResourceInfo.ast at line 3
    // Declared in HighLevelResourceInfo.ast line 40

    public ServiceAddress() {
        super();

        setChild(null, 0);
        setChild(new Opt(), 1);
        setChild(new Opt(), 2);

    }

    // Declared in HighLevelResourceInfo.ast at line 13


    // Declared in HighLevelResourceInfo.ast line 40
    public ServiceAddress(ServiceInstanceID p0, Opt p1, Opt p2) {
        setChild(p0, 0);
        setChild(p1, 1);
        setChild(p2, 2);
    }

    // Declared in HighLevelResourceInfo.ast at line 19


  protected int numChildren() {
    return 3;
  }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 40
    public void setServiceInstanceID(ServiceInstanceID node) {
        setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public ServiceInstanceID getServiceInstanceID() {
        return (ServiceInstanceID)getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public ServiceInstanceID getServiceInstanceIDNoTransform() {
        return (ServiceInstanceID)getChildNoTransform(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 40
    public void setPRDServiceOpt(Opt opt) {
        setChild(opt, 1);
    }

    // Declared in HighLevelResourceInfo.ast at line 6


    public boolean hasPRDService() {
        return getPRDServiceOpt().getNumChild() != 0;
    }

    // Declared in HighLevelResourceInfo.ast at line 10


    public PRDService getPRDService() {
        return (PRDService)getPRDServiceOpt().getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 14


    public void setPRDService(PRDService node) {
        getPRDServiceOpt().setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 17

    public Opt getPRDServiceOpt() {
        return (Opt)getChild(1);
    }

    // Declared in HighLevelResourceInfo.ast at line 21


    public Opt getPRDServiceOptNoTransform() {
        return (Opt)getChildNoTransform(1);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 40
    public void setLocalSIDOpt(Opt opt) {
        setChild(opt, 2);
    }

    // Declared in HighLevelResourceInfo.ast at line 6


    public boolean hasLocalSID() {
        return getLocalSIDOpt().getNumChild() != 0;
    }

    // Declared in HighLevelResourceInfo.ast at line 10


    public LocalSID getLocalSID() {
        return (LocalSID)getLocalSIDOpt().getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 14


    public void setLocalSID(LocalSID node) {
        getLocalSIDOpt().setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 17

    public Opt getLocalSIDOpt() {
        return (Opt)getChild(2);
    }

    // Declared in HighLevelResourceInfo.ast at line 21


    public Opt getLocalSIDOptNoTransform() {
        return (Opt)getChildNoTransform(2);
    }

    protected boolean tryGetLocalSID_visited = false;
    // Declared in LocalSID.jadd at line 22
    public LocalSID tryGetLocalSID() {
        if(tryGetLocalSID_visited)
            throw new RuntimeException("Circular definition of attr: tryGetLocalSID in class: ");
        tryGetLocalSID_visited = true;
        LocalSID tryGetLocalSID_value = tryGetLocalSID_compute();
        tryGetLocalSID_visited = false;
        return tryGetLocalSID_value;
    }

    private LocalSID tryGetLocalSID_compute()  {
		if(hasLocalSID())
			return getLocalSID();
		else if(hasPRDService()) 
			return getPRDService().getLocalSID();
		else
			return super.tryGetLocalSID();
	}

    protected boolean getDeviceAddress_visited = false;
    // Declared in Address.jadd at line 40
    public DeviceAddress getDeviceAddress() {
        if(getDeviceAddress_visited)
            throw new RuntimeException("Circular definition of attr: getDeviceAddress in class: ");
        getDeviceAddress_visited = true;
        DeviceAddress getDeviceAddress_value = getDeviceAddress_compute();
        getDeviceAddress_visited = false;
        return getDeviceAddress_value;
    }

    private DeviceAddress getDeviceAddress_compute()  {
		if(getServiceInstanceID() != null) {
			if(getServiceInstanceID().hasDeviceID()) {
				DeviceID did = getServiceInstanceID().getDeviceID();
				if(hasPRDService()) {
					PRDService service = getPRDService();
					LocalSID localSID = service.getLocalSID();
					DeviceID deviceID = localSID.getDeviceID();
					if(!did.equals(deviceID)) {
						System.err.println("Warning! ServiceAddress: DeviceID mismatch in PRDService:"+service.getName()+":"+did+ "!="+deviceID);
					}
				}
				if(hasLocalSID()){
					if(!getLocalSID().getDeviceID().equals(did)) {
						System.err.println("Warning! ServiceAddress: DeviceID mismatch in LocalSID"+did+ "!="+getLocalSID().getDeviceID());
					}
				}
		
				return new DeviceAddress(new PRDDevice(getServiceInstanceID().getDeviceID()));
			} else {
				System.err.println("Warning: ServiceAddress.getDeviceAddress: SIID has no DeviceID??? "+getServiceInstanceID());
				return null;
			}
		} else {
			System.err.println("Warning! ServiceAddress.getDeviceAddress(): SIID == null????"+this);			
			return null;
//			throw new Error("ServiceAddress.getDeviceAddress(): SIID == null????");
		}
	}

    protected java.util.Set matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
    // Declared in Comparison.jadd at line 102
    public boolean matchesLocalSID(LocalSID l) {
        Object _parameters = l;
        if(matchesLocalSID_LocalSID_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesLocalSID in class: ");
        matchesLocalSID_LocalSID_visited.add(_parameters);
        boolean matchesLocalSID_LocalSID_value = matchesLocalSID_compute(l);
        matchesLocalSID_LocalSID_visited.remove(_parameters);
        return matchesLocalSID_LocalSID_value;
    }

    private boolean matchesLocalSID_compute(LocalSID l) {  return 
		hasLocalSID() && getLocalSID().equals(l);  }

    protected boolean getName_visited = false;
    // Declared in ServiceName.jadd at line 2
    public String getName() {
        if(getName_visited)
            throw new RuntimeException("Circular definition of attr: getName in class: ");
        getName_visited = true;
        String getName_value = getName_compute();
        getName_visited = false;
        return getName_value;
    }

    private String getName_compute()  {
		if(hasPRDService()) {
			return getPRDService().getName();
		} else {
			return "service";
		}
	}

    protected boolean toString_visited = false;
    // Declared in displayStrings.jadd at line 9
    public String toString() {
        if(toString_visited)
            throw new RuntimeException("Circular definition of attr: toString in class: ");
        toString_visited = true;
        String toString_value = toString_compute();
        toString_visited = false;
        return toString_value;
    }

    private String toString_compute()  {
		if(hasPRDService()) {
			return getPRDService().toString();
		} else if (hasLocalSID()) {
			return getLocalSID().toString();
		} else {
			return getServiceInstanceID().toString();
		}
	}

}
