/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ServiceDecl extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getServiceAddr_visited = false;
        lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        lookupService_Identifier_visited = new java.util.HashSet(4);
        getErrorList_visited = false;
        getAssemblyLabel_visited = false;
        prettyPrintChildren_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ServiceDecl node = (ServiceDecl)super.clone();
        node.getServiceAddr_visited = false;
        node.lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        node.lookupService_Identifier_visited = new java.util.HashSet(4);
        node.getErrorList_visited = false;
        node.getAssemblyLabel_visited = false;
        node.prettyPrintChildren_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ServiceDecl node = (ServiceDecl)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ServiceDecl res = (ServiceDecl)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AltService.jadd at line 161

    
    public void listenForDiscovery(ResourceAddressingManager man, PalcomThread t, boolean active) {
    	getDecl().listenForDiscovery(man,t,active);
    }

    // Declared in AssemblyNameEditing.jadd at line 62


	public String getIDforEditing() {
		return getLocalName().getID();
	}

    // Declared in AssemblyNameEditing.jadd at line 107


	public boolean updateIDfromEditor(String id) {
		if(!getLocalName().getID().equals(id)) {
			getLocalName().setID(id);
			return true;
		}
		return false;
	}

    // Declared in AssemblyTree.jadd at line 108

	
	public Object[] getChildArray() {
//		return new Object[] {getLocalName(), getServiceName(), getDeviceUse(), getURN()};
//		return new Object[] {getServiceName(), getDeviceUse(), getURN()};
		if(getDecl() != null)
			return getDecl().getChildArray();
		else
			return new Object[0];
	}

    // Declared in AssemblyXML.jadd at line 220


    public String getTagName() {
    	return "ServiceDecl";
    }

    // Declared in AssemblyXML.jadd at line 224

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        getLocalName().writeXMLElement(serializer);
        getDecl().writeXMLElement(serializer);
        serializer.endTag(null, getTagName());
    }

    // Declared in AssemblyXML.jadd at line 232

    
    public void initializeFromElement(XmlPullParser parser) {
    }

    // Declared in AssemblyXML.jadd at line 235


	public void addChildFromXMLElement(XMLRepresentable child) {
		if(child instanceof Identifier) {
			setLocalName((Identifier) child);
		} else if(child instanceof AbstractServiceDecl) {
			setDecl((AbstractServiceDecl) child);
		}
	}

    // Declared in HLAAddress.jadd at line 13

	
	public void validateAddress(ResourceAddressingManager m) {
		getDecl().validateAddress(m);
	}

    // Declared in OnLineEditing.jadd at line 52

	
	public void addToAssembly(Assembly a) {
		PRDAssemblyVer ai = a.assemblyVer;
		ServiceDecl sd = ai.getServices().lookupService(getLocalName());
		if(sd == null) {
			// none found, add this
			ai.getServices().addServiceDecl(this);		
		} else {
			if(sd.getDecl() instanceof SingleServiceDecl) {
				SingleServiceDecl ssd = (SingleServiceDecl) sd.getDecl();
				SingleServiceDecl ssd2 = (SingleServiceDecl) getDecl();
				
				AltServiceDeclList asdl = new AltServiceDeclList();
				AltServiceDecl asd = new AltServiceDecl(ssd.getServiceName(), ssd.getDeviceUse(), ssd.getServiceAddress(), "1");
				AltServiceDecl asd2 = new AltServiceDecl(ssd2.getServiceName(), ssd2.getDeviceUse(), ssd2.getServiceAddress(), "1");
				asdl.addServiceDecl(asd);
				asdl.addServiceDecl(asd2);
				ServiceDecl newSd = new ServiceDecl(getLocalName(), asdl);		
				a.replaceServiceDecl(sd, newSd);
			} else if (sd.getDecl() instanceof AltServiceDeclList ) {
				AltServiceDeclList asdl = (AltServiceDeclList) sd.getDecl();
				SingleServiceDecl ssd2 = (SingleServiceDecl) getDecl();
				AltServiceDecl asd2 = new AltServiceDecl(ssd2.getServiceName(), ssd2.getDeviceUse(), ssd2.getServiceAddress(), "1");
				asdl.addServiceDecl(asd2);
				ServiceDecl newSd = new ServiceDecl(getLocalName(), asdl);		
				a.replaceServiceDecl(sd, newSd);				
			}else {
				System.out.println("ServiceDecl.addToAssembly failed");
			}
		}
		ai.resetTree();
		//connectAffectedConnections(a);
	}

    // Declared in OnLineEditing.jadd at line 105

	
	public void removeFromAssembly(Assembly a) {
		PRDAssemblyVer ai = a.assemblyVer;
		//disconnectAffectedConnections(a);
		ai.getServices().lookupService(getLocalName()).remove();
		ai.resetTree();
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 50

    public ServiceDecl() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in Assembly.ast at line 12


    // Declared in Assembly.ast line 50
    public ServiceDecl(Identifier p0, AbstractServiceDecl p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in Assembly.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 50
    public void setLocalName(Identifier node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public Identifier getLocalName() {
        return (Identifier)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public Identifier getLocalNameNoTransform() {
        return (Identifier)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 50
    public void setDecl(AbstractServiceDecl node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public AbstractServiceDecl getDecl() {
        return (AbstractServiceDecl)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public AbstractServiceDecl getDeclNoTransform() {
        return (AbstractServiceDecl)getChildNoTransform(1);
    }

    protected boolean getServiceAddr_visited = false;
/** Attribute used in name analysis. Named *Addr to avoid name clash
    Declared in AssemblyNameAnalysis.jrag at line 117
*/
    public ServiceAddress getServiceAddr() {
        if(getServiceAddr_visited)
            throw new RuntimeException("Circular definition of attr: getServiceAddr in class: ");
        getServiceAddr_visited = true;
        ServiceAddress getServiceAddr_value = getServiceAddr_compute();
        getServiceAddr_visited = false;
        return getServiceAddr_value;
    }

    private ServiceAddress getServiceAddr_compute() {  return  getDecl().getServiceAddr();  }

    protected java.util.Set lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 138
    public ServiceDecl lookupService(AbstractResourceAddress sa) {
        Object _parameters = sa;
        if(lookupService_AbstractResourceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_AbstractResourceAddress_visited.add(_parameters);
        ServiceDecl lookupService_AbstractResourceAddress_value = lookupService_compute(sa);
        lookupService_AbstractResourceAddress_visited.remove(_parameters);
        return lookupService_AbstractResourceAddress_value;
    }

    private ServiceDecl lookupService_compute(AbstractResourceAddress sa) {  return  getDecl().lookupService(sa) != null ? this : null;  }

    protected java.util.Set lookupService_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 199
    public ServiceDecl lookupService(Identifier id) {
        Object _parameters = id;
        if(lookupService_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_Identifier_visited.add(_parameters);
        ServiceDecl lookupService_Identifier_value = lookupService_compute(id);
        lookupService_Identifier_visited.remove(_parameters);
        return lookupService_Identifier_value;
    }

    private ServiceDecl lookupService_compute(Identifier id) {  return  getDecl().lookupService(id) != null ? this:null;  }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 66
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute() {  return  getDecl().getErrorList();  }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 168
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getLocalName()+" : "+getDecl().getAssemblyLabel();  }

    protected boolean prettyPrintChildren_visited = false;
    // Declared in PrettyPrint.jrag at line 62
    public boolean prettyPrintChildren() {
        if(prettyPrintChildren_visited)
            throw new RuntimeException("Circular definition of attr: prettyPrintChildren in class: ");
        prettyPrintChildren_visited = true;
        boolean prettyPrintChildren_value = prettyPrintChildren_compute();
        prettyPrintChildren_visited = false;
        return prettyPrintChildren_value;
    }

    private boolean prettyPrintChildren_compute() {  return  false;  }

    // Declared in AltService.jadd at line 44
    public Identifier Define_Identifier_getLocalName(ASTNode caller, ASTNode child) {
        if(caller == getDeclNoTransform()) {
            return  getLocalName();
        }
        return getParent().Define_Identifier_getLocalName(this, caller);
    }

}
