/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ServiceDeclList extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupService_ServiceAddress_visited = new java.util.HashSet(4);
        lookupService_Identifier_visited = new java.util.HashSet(4);
        getAssemblyLabel_visited = false;
        encloseInBraces_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ServiceDeclList node = (ServiceDeclList)super.clone();
        node.lookupService_ServiceAddress_visited = new java.util.HashSet(4);
        node.lookupService_Identifier_visited = new java.util.HashSet(4);
        node.getAssemblyLabel_visited = false;
        node.encloseInBraces_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ServiceDeclList node = (ServiceDeclList)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ServiceDeclList res = (ServiceDeclList)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyTree.jadd at line 93


	public Object[] getChildArray() {
		return getServiceDeclList().getChildArray();
//		return new Object[] {"ServiceInfoList"};
	}

    // Declared in AssemblyXML.jadd at line 153


    public String getTagName() {
    	return "ServiceDeclList";
    }

    // Declared in AssemblyXML.jadd at line 157

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        for (int i = 0; i < getNumServiceDecl(); i++) {
            getServiceDecl(i).writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in AssemblyXML.jadd at line 166

    
    public void initializeFromElement(XmlPullParser parser) {
    }

    // Declared in AssemblyXML.jadd at line 169

        
    public void addChildFromXMLElement(XMLRepresentable child) {
        addServiceDecl((ServiceDecl) child);
    }

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 44

    public ServiceDeclList() {
        super();

        setChild(new List(), 0);

    }

    // Declared in Assembly.ast at line 11


    // Declared in Assembly.ast line 44
    public ServiceDeclList(List p0) {
        setChild(p0, 0);
    }

    // Declared in Assembly.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 44
    public void setServiceDeclList(List list) {
        setChild(list, 0);
    }

    // Declared in Assembly.ast at line 6


    public int getNumServiceDecl() {
        return getServiceDeclList().getNumChild();
    }

    // Declared in Assembly.ast at line 10


    public ServiceDecl getServiceDecl(int i) {
        return (ServiceDecl)getServiceDeclList().getChild(i);
    }

    // Declared in Assembly.ast at line 14


    public void addServiceDecl(ServiceDecl node) {
        List list = getServiceDeclList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in Assembly.ast at line 19


    public void setServiceDecl(ServiceDecl node, int i) {
        List list = getServiceDeclList();
        list.setChild(node, i);
    }

    // Declared in Assembly.ast at line 23

    public List getServiceDeclList() {
        return (List)getChild(0);
    }

    // Declared in Assembly.ast at line 27


    public List getServiceDeclListNoTransform() {
        return (List)getChildNoTransform(0);
    }

    protected java.util.Set lookupService_ServiceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 104
    public ServiceDecl lookupService(ServiceAddress sa) {
        Object _parameters = sa;
        if(lookupService_ServiceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_ServiceAddress_visited.add(_parameters);
        ServiceDecl lookupService_ServiceAddress_value = lookupService_compute(sa);
        lookupService_ServiceAddress_visited.remove(_parameters);
        return lookupService_ServiceAddress_value;
    }

    private ServiceDecl lookupService_compute(ServiceAddress sa)  {
        for (int i = 0; i < getNumServiceDecl(); i++) {
            ServiceDecl decl = getServiceDecl(i).lookupService(sa);
            if (decl != null) {
                return decl;
            }
        }
        return null;
    }

    protected java.util.Set lookupService_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 186
    public ServiceDecl lookupService(Identifier id) {
        Object _parameters = id;
        if(lookupService_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_Identifier_visited.add(_parameters);
        ServiceDecl lookupService_Identifier_value = lookupService_compute(id);
        lookupService_Identifier_visited.remove(_parameters);
        return lookupService_Identifier_value;
    }

    private ServiceDecl lookupService_compute(Identifier id)  {
         for (int i = 0; i < getNumServiceDecl(); i++) {
             ServiceDecl decl = getServiceDecl(i).lookupService(id);
             if (decl != null) {
                 return decl;
             }
         }
         return null;
     }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 165
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  "Services";  }

    protected boolean encloseInBraces_visited = false;
    // Declared in PrettyPrint.jrag at line 69
    public boolean encloseInBraces() {
        if(encloseInBraces_visited)
            throw new RuntimeException("Circular definition of attr: encloseInBraces in class: ");
        encloseInBraces_visited = true;
        boolean encloseInBraces_value = encloseInBraces_compute();
        encloseInBraces_visited = false;
        return encloseInBraces_value;
    }

    private boolean encloseInBraces_compute() {  return  true;  }

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 56
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

}
