/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


                      
public class ServiceDescription extends Info implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupCommand_String_visited = new java.util.HashSet(4);
        getID_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ServiceDescription node = (ServiceDescription)super.clone();
        node.lookupCommand_String_visited = new java.util.HashSet(4);
        node.getID_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ServiceDescription node = (ServiceDescription)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ServiceDescription res = (ServiceDescription)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in HLAXML.jadd at line 41

	public String getTagName() {
		return "ServiceDescription";
	}

    // Declared in HLAXML.jadd at line 45

	
	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
      	serializer.startTag(null, getTagName());
		getServiceAddress().writeXMLElement(serializer);
		getPRDServiceFMDescription().writeXMLElement(serializer);
		serializer.endTag(null, getTagName());
	}

    // Declared in HLAXML.jadd at line 52

	
	public void addChildFromXMLElement(XMLRepresentable child) {
		if(child instanceof ServiceAddress) {
			setServiceAddress((ServiceAddress)child);
		} else if(child instanceof PRDServiceFMDescription) {
			setPRDServiceFMDescription((PRDServiceFMDescription)child);
		} else {
			System.err.println("WARNING! ServiceDescription.addChildFromXMLElement: unknown class: "+child.getClass());
		}
	}

    // Declared in glue.jadd at line 2

	int getNumControlInfo() {
		return getPRDServiceFMDescription().getNumControlInfo();
	}

    // Declared in glue.jadd at line 5

	ControlInfo getControlInfo(int i) {
		return getPRDServiceFMDescription().getControlInfo(i);
	}

    // Declared in HighLevelResourceInfo.ast at line 3
    // Declared in HighLevelResourceInfo.ast line 53

    public ServiceDescription() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in HighLevelResourceInfo.ast at line 12


    // Declared in HighLevelResourceInfo.ast line 53
    public ServiceDescription(AbstractResourceAddress p0, PRDServiceFMDescription p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in HighLevelResourceInfo.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 53
    public void setServiceAddress(AbstractResourceAddress node) {
        setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public AbstractResourceAddress getServiceAddress() {
        return (AbstractResourceAddress)getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public AbstractResourceAddress getServiceAddressNoTransform() {
        return (AbstractResourceAddress)getChildNoTransform(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 53
    public void setPRDServiceFMDescription(PRDServiceFMDescription node) {
        setChild(node, 1);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public PRDServiceFMDescription getPRDServiceFMDescription() {
        return (PRDServiceFMDescription)getChild(1);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public PRDServiceFMDescription getPRDServiceFMDescriptionNoTransform() {
        return (PRDServiceFMDescription)getChildNoTransform(1);
    }

    protected java.util.Set lookupCommand_String_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 211
    public ControlInfo lookupCommand(String id) {
        Object _parameters = id;
        if(lookupCommand_String_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupCommand in class: ");
        lookupCommand_String_visited.add(_parameters);
        ControlInfo lookupCommand_String_value = lookupCommand_compute(id);
        lookupCommand_String_visited.remove(_parameters);
        return lookupCommand_String_value;
    }

    private ControlInfo lookupCommand_compute(String id)  {
	for(int i=0; i < getNumControlInfo(); i++) {
		ControlInfo ci = getControlInfo(i).lookupCommand(id);
		if(ci instanceof CommandInfo)
			return ci;
	}
	return null;
}

    protected boolean getID_visited = false;
    // Declared in SDID.jadd at line 2
    public String getID() {
        if(getID_visited)
            throw new RuntimeException("Circular definition of attr: getID in class: ");
        getID_visited = true;
        String getID_value = getID_compute();
        getID_visited = false;
        return getID_value;
    }

    private String getID_compute() {  return  getPRDServiceFMDescription().getID();  }

}
