/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class SingleServiceDecl extends AbstractServiceDecl implements Cloneable {
    public void flushCache() {
        super.flushCache();
        isAlternative_visited = false;
        getServiceAddr_visited = false;
        lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        lookupService_Identifier_visited = new java.util.HashSet(4);
        getErrorList_visited = false;
        getAssemblyLabel_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        SingleServiceDecl node = (SingleServiceDecl)super.clone();
        node.isAlternative_visited = false;
        node.getServiceAddr_visited = false;
        node.lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
        node.lookupService_Identifier_visited = new java.util.HashSet(4);
        node.getErrorList_visited = false;
        node.getAssemblyLabel_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          SingleServiceDecl node = (SingleServiceDecl)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        SingleServiceDecl res = (SingleServiceDecl)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AltService.jadd at line 46


    public String getTagName() {
    	return "SingleServiceDecl";
    }

    // Declared in AltService.jadd at line 52


    public void writeXMLElementBody(KXmlSerializer serializer) throws IOException{
//        serializer.attribute(null, "urnSuffix", getURNSuffix());
//        getLocalName().writeXMLElement(serializer);
        getServiceName().writeXMLElement(serializer);
        getDeviceUse().writeXMLElement(serializer);
        getServiceAddress().writeXMLElement(serializer);    	
    }

    // Declared in AltService.jadd at line 70

    
    public void initializeFromElement(XmlPullParser parser) {
	    //setServiceName(parser.getAttributeValue(null, "serviceName"));
	    //setURNSuffix(parser.getAttributeValue(null, "urnSuffix"));
    }

    // Declared in AltService.jadd at line 75


	public void addChildFromXMLElement(XMLRepresentable child) {    
		if(child instanceof DeviceUse) {
			setDeviceUse((DeviceUse)child);
		} else if( child instanceof ServiceInstanceID) {
			System.err.println("WARNING! SingleServiceDecl.addChildFromXMLElement ignoring PRDService and LocalSID");
			setServiceAddress(new ServiceAddress((ServiceInstanceID) child, new Opt(), new Opt()));
		} else if(child instanceof ServiceAddress) {
			setServiceAddress((ServiceAddress)child);
		} else if (child instanceof Identifier) {
			// XXX remove this if statement?
//			if(getLocalName() == null)
//				setLocalName((Identifier) child);
//			else
				setServiceName((Identifier)child);
		}
	}

    // Declared in AltService.jadd at line 167

    
    public void listenForDiscovery(ResourceAddressingManager man, PalcomThread t, boolean active) {
    	System.err.println("SingleServiceDecl.listenForDiscovery broken by changes");
    	DeviceAddress da = getDeviceUse().getDecl().getDeviceAddress();
    	if(active) {
    		man.listenForDevices(t);
        	man.listenForServices(t, da);
        	man.listenForConnections(t,da);
//    		man.updatePRDDeviceReceiver(t);
//	   		man.updatePRDServiceListReceiver(new LocalSID(aURN.toString()), t);
//			man.updatePRDConnectionReceiver(new DeviceID(aURN.toString()), t);    
		} else {
			System.err.println("Warning: SingleServiceDecl: deregistering from discovery not implemented!");
//			man.removePRDDeviceReceiver(t);
//   			man.removePRDServiceListReceiver(new LocalSID(aURN.toString()), t);
//			man.removePRDConnectionReceiver(new DeviceID(aURN.toString()), t);    
		}
    }

    // Declared in HLAAddress.jadd at line 21

	
	public void validateAddress(ResourceAddressingManager m) {
		AbstractResourceAddress tmp = m.validateAddress(getServiceAddress());
		if(tmp instanceof ServiceAddress) {
			if(tmp != getServiceAddress()) {
				setServiceAddress((ServiceAddress)tmp);
			}
		} else {
			System.err.println("WARNING! SingleServiceDecl.validateAddress: got "+tmp.getClass().getName());
		}
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 54

    public SingleServiceDecl() {
        super();

        setChild(null, 0);
        setChild(null, 1);
        setChild(null, 2);

    }

    // Declared in Assembly.ast at line 13


    // Declared in Assembly.ast line 54
    public SingleServiceDecl(Identifier p0, DeviceUse p1, ServiceAddress p2) {
        setChild(p0, 0);
        setChild(p1, 1);
        setChild(p2, 2);
    }

    // Declared in Assembly.ast at line 19


  protected int numChildren() {
    return 3;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 54
    public void setServiceName(Identifier node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public Identifier getServiceName() {
        return (Identifier)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public Identifier getServiceNameNoTransform() {
        return (Identifier)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 54
    public void setDeviceUse(DeviceUse node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public DeviceUse getDeviceUse() {
        return (DeviceUse)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public DeviceUse getDeviceUseNoTransform() {
        return (DeviceUse)getChildNoTransform(1);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 54
    public void setServiceAddress(ServiceAddress node) {
        setChild(node, 2);
    }

    // Declared in Assembly.ast at line 5

    public ServiceAddress getServiceAddress() {
        return (ServiceAddress)getChild(2);
    }

    // Declared in Assembly.ast at line 9


    public ServiceAddress getServiceAddressNoTransform() {
        return (ServiceAddress)getChildNoTransform(2);
    }

    protected boolean isAlternative_visited = false;
    // Declared in AltService.jadd at line 141
    public boolean isAlternative() {
        if(isAlternative_visited)
            throw new RuntimeException("Circular definition of attr: isAlternative in class: ");
        isAlternative_visited = true;
        boolean isAlternative_value = isAlternative_compute();
        isAlternative_visited = false;
        return isAlternative_value;
    }

    private boolean isAlternative_compute() {  return  false;  }

    protected boolean getServiceAddr_visited = false;
    // Declared in AssemblyNameAnalysis.jrag at line 125
    public ServiceAddress getServiceAddr() {
        if(getServiceAddr_visited)
            throw new RuntimeException("Circular definition of attr: getServiceAddr in class: ");
        getServiceAddr_visited = true;
        ServiceAddress getServiceAddr_value = getServiceAddr_compute();
        getServiceAddr_visited = false;
        return getServiceAddr_value;
    }

    private ServiceAddress getServiceAddr_compute()  {
    	return getServiceAddress();
///    	DeviceDecl dd = getDeviceUse().getDecl();
///    	if(dd != null) {
///    		URN myURN = new URN(dd.getURN() + getURNSuffix());
///    		return myURN;
///    	} else {
///    		return new URN(getServiceName().getID()+" on unknown device "+getDeviceUse().getIdentifier().getID());
///    	}
    }

    protected java.util.Set lookupService_AbstractResourceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 154
    public AbstractServiceDecl lookupService(AbstractResourceAddress sa) {
        Object _parameters = sa;
        if(lookupService_AbstractResourceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_AbstractResourceAddress_visited.add(_parameters);
        AbstractServiceDecl lookupService_AbstractResourceAddress_value = lookupService_compute(sa);
        lookupService_AbstractResourceAddress_visited.remove(_parameters);
        return lookupService_AbstractResourceAddress_value;
    }

    private AbstractServiceDecl lookupService_compute(AbstractResourceAddress sa) {  return  sa.equals(getServiceAddress()) ? this : null;  }

    protected java.util.Set lookupService_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 216
    public AbstractServiceDecl lookupService(Identifier id) {
        Object _parameters = id;
        if(lookupService_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_Identifier_visited.add(_parameters);
        AbstractServiceDecl lookupService_Identifier_value = lookupService_compute(id);
        lookupService_Identifier_visited.remove(_parameters);
        return lookupService_Identifier_value;
    }

    private AbstractServiceDecl lookupService_compute(Identifier id) {  return  
         id.equals(getLocalName()) ? this : null;  }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 73
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute()  {
    	DeviceDecl dd = getDeviceUse().getDecl();
    	ArrayList l = new ArrayList();
    	if(dd == null) {
			l.add(l.size(),new SemanticError(SemanticError.TYPE_ERROR,"Unknown device "+getDeviceUse().getIdentifier().getID()+" in declaration of service "+getServiceName().getID(), this));
//    		l.add(new SemanticError(SemanticError.TYPE_ERROR,"Declared service "+getServiceName().getID()+" on unknown device "+getDeviceUse().getIdentifier().getID()));
    	} 
    	return l;
	}

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 169
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  av().lookupAndFormatAddress(getServiceAddress());  }

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 59
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

}
