/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class SubListInfo extends ServiceInfoListItem implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getAddress_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        SubListInfo node = (SubListInfo)super.clone();
        node.getAddress_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          SubListInfo node = (SubListInfo)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        SubListInfo res = (SubListInfo)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 59


public ServiceListPart createServiceNode() {
	SubList result = new SubList(this, getName(), getKind(), new List());
	return result;
}

    // Declared in HLAXML.jadd at line 62
	
	
	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
      	serializer.startTag(null, getTagName());
      	serializer.attribute(null, "name", getName());
      	serializer.attribute(null, "kind", getKind());
      	getAddress().writeXMLElement(serializer);
		serializer.endTag(null, getTagName());
	}

    // Declared in HLAXML.jadd at line 70

	
	public void initializeFromElement(XmlPullParser parser) {
		setName(parser.getAttributeValue(null, "name"));
		setKind(parser.getAttributeValue(null, "kind"));
    }

    // Declared in HighLevelResourceInfo.ast at line 3
    // Declared in HighLevelResourceInfo.ast line 51

    public SubListInfo() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in HighLevelResourceInfo.ast at line 12


    // Declared in HighLevelResourceInfo.ast line 51
    public SubListInfo(AbstractResourceAddress p0, TemporaryAddress p1, String p2, String p3) {
        setChild(p0, 0);
        setChild(p1, 1);
        setName(p2);
        setKind(p3);
    }

    // Declared in HighLevelResourceInfo.ast at line 19


  protected int numChildren() {
    return 2;
  }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 51
    public void setParentAddress(AbstractResourceAddress node) {
        setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public AbstractResourceAddress getParentAddress() {
        return (AbstractResourceAddress)getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public AbstractResourceAddress getParentAddressNoTransform() {
        return (AbstractResourceAddress)getChildNoTransform(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 51
    public void setListAddress(TemporaryAddress node) {
        setChild(node, 1);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public TemporaryAddress getListAddress() {
        return (TemporaryAddress)getChild(1);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public TemporaryAddress getListAddressNoTransform() {
        return (TemporaryAddress)getChildNoTransform(1);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 51
    private String tokenString_Name;

    // Declared in HighLevelResourceInfo.ast at line 3

    public void setName(String value) {
        tokenString_Name = value;
    }

    // Declared in HighLevelResourceInfo.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 51
    private String tokenString_Kind;

    // Declared in HighLevelResourceInfo.ast at line 3

    public void setKind(String value) {
        tokenString_Kind = value;
    }

    // Declared in HighLevelResourceInfo.ast at line 6

    public String getKind() {
        return tokenString_Kind;
    }

    protected boolean getAddress_visited = false;
    // Declared in Address.jadd at line 14
    public AbstractResourceAddress getAddress() {
        if(getAddress_visited)
            throw new RuntimeException("Circular definition of attr: getAddress in class: ");
        getAddress_visited = true;
        AbstractResourceAddress getAddress_value = getAddress_compute();
        getAddress_visited = false;
        return getAddress_value;
    }

    private AbstractResourceAddress getAddress_compute()  {
		return getListAddress();
	}

}
