/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ThisProviderService extends ServiceExp implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getLocalSID_visited = false;
        provServiceAddress_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ThisProviderService node = (ThisProviderService)super.clone();
        node.getLocalSID_visited = false;
        node.provServiceAddress_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ThisProviderService node = (ThisProviderService)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ThisProviderService res = (ThisProviderService)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyScript.jadd at line 110

	public AbstractResourceAddress getServiceAddress() {
		return provServiceAddress();
	}

    // Declared in AssemblyXML.jadd at line 362


	public String getTagName() {
		return "ThisProviderService";
	}

    // Declared in AssemblyXML.jadd at line 366


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        serializer.endTag(null, getTagName());
	}

    // Declared in AssemblyXML.jadd at line 371


	public void initializeFromElement(XmlPullParser parser) {
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 66

    public ThisProviderService() {
        super();


    }

    // Declared in Assembly.ast at line 9


  protected int numChildren() {
    return 0;
  }

    protected boolean getLocalSID_visited = false;
    // Declared in LocalSID.jadd at line 15
    public LocalSID getLocalSID() {
        if(getLocalSID_visited)
            throw new RuntimeException("Circular definition of attr: getLocalSID in class: ");
        getLocalSID_visited = true;
        LocalSID getLocalSID_value = getLocalSID_compute();
        getLocalSID_visited = false;
        return getLocalSID_value;
    }

    private LocalSID getLocalSID_compute()  {
	 	System.err.println("ThisProviderService.getLocalSID() not implemented");
		return null;	 
	}

    protected boolean provServiceAddress_visited = false;
    // Declared in AssemblyScript.jadd at line 99
    public AbstractResourceAddress provServiceAddress() {
        if(provServiceAddress_visited)
            throw new RuntimeException("Circular definition of attr: provServiceAddress in class: ");
        provServiceAddress_visited = true;
        AbstractResourceAddress provServiceAddress_value = getParent().Define_AbstractResourceAddress_provServiceAddress(this, null);
        provServiceAddress_visited = false;
        return provServiceAddress_value;
    }

}
