/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ThisProviderServiceAddress extends ServiceAddress implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        ThisProviderServiceAddress node = (ThisProviderServiceAddress)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          ThisProviderServiceAddress node = (ThisProviderServiceAddress)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ThisProviderServiceAddress res = (ThisProviderServiceAddress)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 69

    public ThisProviderServiceAddress() {
        super();

        setChild(null, 0);
        setChild(new Opt(), 1);
        setChild(new Opt(), 2);

    }

    // Declared in Assembly.ast at line 13


    // Declared in Assembly.ast line 69
    public ThisProviderServiceAddress(ServiceInstanceID p0, Opt p1, Opt p2) {
        setChild(p0, 0);
        setChild(p1, 1);
        setChild(p2, 2);
    }

    // Declared in Assembly.ast at line 19


  protected int numChildren() {
    return 3;
  }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 40
    public void setServiceInstanceID(ServiceInstanceID node) {
        setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public ServiceInstanceID getServiceInstanceID() {
        return (ServiceInstanceID)getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public ServiceInstanceID getServiceInstanceIDNoTransform() {
        return (ServiceInstanceID)getChildNoTransform(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 40
    public void setPRDServiceOpt(Opt opt) {
        setChild(opt, 1);
    }

    // Declared in HighLevelResourceInfo.ast at line 6


    public boolean hasPRDService() {
        return getPRDServiceOpt().getNumChild() != 0;
    }

    // Declared in HighLevelResourceInfo.ast at line 10


    public PRDService getPRDService() {
        return (PRDService)getPRDServiceOpt().getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 14


    public void setPRDService(PRDService node) {
        getPRDServiceOpt().setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 17

    public Opt getPRDServiceOpt() {
        return (Opt)getChild(1);
    }

    // Declared in HighLevelResourceInfo.ast at line 21


    public Opt getPRDServiceOptNoTransform() {
        return (Opt)getChildNoTransform(1);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 40
    public void setLocalSIDOpt(Opt opt) {
        setChild(opt, 2);
    }

    // Declared in HighLevelResourceInfo.ast at line 6


    public boolean hasLocalSID() {
        return getLocalSIDOpt().getNumChild() != 0;
    }

    // Declared in HighLevelResourceInfo.ast at line 10


    public LocalSID getLocalSID() {
        return (LocalSID)getLocalSIDOpt().getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 14


    public void setLocalSID(LocalSID node) {
        getLocalSIDOpt().setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 17

    public Opt getLocalSIDOpt() {
        return (Opt)getChild(2);
    }

    // Declared in HighLevelResourceInfo.ast at line 21


    public Opt getLocalSIDOptNoTransform() {
        return (Opt)getChildNoTransform(2);
    }

}
