/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;




public class UnboundServiceDeclList extends ServiceData implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        UnboundServiceDeclList node = (UnboundServiceDeclList)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          UnboundServiceDeclList node = (UnboundServiceDeclList)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        UnboundServiceDeclList res = (UnboundServiceDeclList)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in UnboundServiceXML.jadd at line 9

    public String getTagName() {
    	return "UnboundServiceDeclList";
    }

    // Declared in UnboundServiceXML.jadd at line 13

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        for(int i=0; i<getNumUnboundServiceDecl();i++) {
        	getUnboundServiceDecl(i).writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in UnboundServiceXML.jadd at line 22

    
    public void initializeFromElement(XmlPullParser parser) {
    }

    // Declared in UnboundServiceXML.jadd at line 25

        
    public void addChildFromXMLElement(XMLRepresentable child) {
        addUnboundServiceDecl((UnboundServiceDecl) child);
    }

    // Declared in UnboundServices.ast at line 3
    // Declared in UnboundServices.ast line 39

    public UnboundServiceDeclList() {
        super();

        setChild(new List(), 0);

    }

    // Declared in UnboundServices.ast at line 11


    // Declared in UnboundServices.ast line 39
    public UnboundServiceDeclList(List p0) {
        setChild(p0, 0);
    }

    // Declared in UnboundServices.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in UnboundServices.ast at line 2
    // Declared in UnboundServices.ast line 39
    public void setUnboundServiceDeclList(List list) {
        setChild(list, 0);
    }

    // Declared in UnboundServices.ast at line 6


    public int getNumUnboundServiceDecl() {
        return getUnboundServiceDeclList().getNumChild();
    }

    // Declared in UnboundServices.ast at line 10


    public UnboundServiceDecl getUnboundServiceDecl(int i) {
        return (UnboundServiceDecl)getUnboundServiceDeclList().getChild(i);
    }

    // Declared in UnboundServices.ast at line 14


    public void addUnboundServiceDecl(UnboundServiceDecl node) {
        List list = getUnboundServiceDeclList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in UnboundServices.ast at line 19


    public void setUnboundServiceDecl(UnboundServiceDecl node, int i) {
        List list = getUnboundServiceDeclList();
        list.setChild(node, i);
    }

    // Declared in UnboundServices.ast at line 23

    public List getUnboundServiceDeclList() {
        return (List)getChild(0);
    }

    // Declared in UnboundServices.ast at line 27


    public List getUnboundServiceDeclListNoTransform() {
        return (List)getChildNoTransform(0);
    }

}
