/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


//Universe:NetworkNode ::= Net:Network Connections:ConnectionInfo*;
public class Universe extends ASTNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getBrowserLabel_visited = false;
        lookup_Object_visited = new java.util.HashSet(4);
    }
    public Object clone() throws CloneNotSupportedException {
        Universe node = (Universe)super.clone();
        node.getBrowserLabel_visited = false;
        node.lookup_Object_visited = new java.util.HashSet(4);
    return node;
    }
    public ASTNode copy() {
      try {
          Universe node = (Universe)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        Universe res = (Universe)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 214


	public Object[] getChildArray() {	
		Object tmp[] = new Object[2];
		tmp[0] = getNet();
		tmp[1] = getConnections();
		return tmp;
   }

    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 41

    public Universe() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in LocalView.ast at line 12


    // Declared in LocalView.ast line 41
    public Universe(Network p0, ConnectionList p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in LocalView.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 41
    public void setNet(Network node) {
        setChild(node, 0);
    }

    // Declared in LocalView.ast at line 5

    public Network getNet() {
        return (Network)getChild(0);
    }

    // Declared in LocalView.ast at line 9


    public Network getNetNoTransform() {
        return (Network)getChildNoTransform(0);
    }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 41
    public void setConnections(ConnectionList node) {
        setChild(node, 1);
    }

    // Declared in LocalView.ast at line 5

    public ConnectionList getConnections() {
        return (ConnectionList)getChild(1);
    }

    // Declared in LocalView.ast at line 9


    public ConnectionList getConnectionsNoTransform() {
        return (ConnectionList)getChildNoTransform(1);
    }

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 57
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute() {  return  "Universe";  }

    protected java.util.Set lookup_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 46
    public NetworkNode lookup(Object o) {
        Object _parameters = o;
        if(lookup_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookup in class: ");
        lookup_Object_visited.add(_parameters);
        NetworkNode lookup_Object_value = lookup_compute(o);
        lookup_Object_visited.remove(_parameters);
        return lookup_Object_value;
    }

    private NetworkNode lookup_compute(Object o)  {
	synchronized(this) {
		return getNet().lookup(o);
	}
}

    // Declared in DeviceTree.jadd at line 103
    public Service Define_Service_inhProv(ASTNode caller, ASTNode child, Connection c) {
        if(caller == getConnectionsNoTransform()) {
	NetworkNode n = getNet().localLookup(c.getInfo().getProviderAddress());
	return (Service) n;
}
        return getParent().Define_Service_inhProv(this, caller, c);
    }

    // Declared in NameAnalysis.jrag at line 52
    public NetworkNode Define_NetworkNode_lookup(ASTNode caller, ASTNode child, Object o) {
        if(caller == getNetNoTransform()) {
	synchronized(this) {
		NetworkNode n = getNet().localLookup(o);
		if(n != null) return n;
		return null;
	}
}
        return getParent().Define_NetworkNode_lookup(this, caller, o);
    }

    // Declared in DeviceTree.jadd at line 90
    public Universe Define_Universe_universe(ASTNode caller, ASTNode child) {
        if(caller == getNetNoTransform()) {
            return  this;
        }
        return getParent().Define_Universe_universe(this, caller);
    }

    // Declared in DeviceTree.jadd at line 96
    public Service Define_Service_inhCust(ASTNode caller, ASTNode child, Connection c) {
        if(caller == getConnectionsNoTransform()) {
	NetworkNode n = getNet().localLookup(c.getInfo().getCustomerAddress());
	return (Service) n;
}
        return getParent().Define_Service_inhCust(this, caller, c);
    }

}
