/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public abstract class Use extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        isDeclared_visited = false;
        typeError_visited = false;
        actualType_visited = false;
        getUseName_visited = false;
        expectedType_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        Use node = (Use)super.clone();
        node.isDeclared_visited = false;
        node.typeError_visited = false;
        node.actualType_visited = false;
        node.getUseName_visited = false;
        node.expectedType_visited = false;
    return node;
    }
    // Declared in AssemblyScript.jadd at line 41


	public byte[] getValue(CommandEvent env) {
		System.out.println("******Use.getValue() should be overridden in "+this.getClass());
		return null;
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 89

    public Use() {
        super();


    }

    // Declared in Assembly.ast at line 9


  protected int numChildren() {
    return 0;
  }

    protected boolean isDeclared_visited = false;
    // Declared in AssemblyNameAnalysis.jrag at line 411
    public boolean isDeclared() {
        if(isDeclared_visited)
            throw new RuntimeException("Circular definition of attr: isDeclared in class: ");
        isDeclared_visited = true;
        boolean isDeclared_value = isDeclared_compute();
        isDeclared_visited = false;
        return isDeclared_value;
    }

    private boolean isDeclared_compute() {  return  false;  }

    protected boolean typeError_visited = false;
    // Declared in AssemblyTypeAnalysis.jrag at line 51
    public boolean typeError() {
        if(typeError_visited)
            throw new RuntimeException("Circular definition of attr: typeError in class: ");
        typeError_visited = true;
        boolean typeError_value = typeError_compute();
        typeError_visited = false;
        return typeError_value;
    }

    private boolean typeError_compute() {  return  ! (actualType().equals(expectedType()));  }

    protected boolean actualType_visited = false;
    // Declared in AssemblyTypeAnalysis.jrag at line 53
    public String actualType() {
        if(actualType_visited)
            throw new RuntimeException("Circular definition of attr: actualType in class: ");
        actualType_visited = true;
        String actualType_value = actualType_compute();
        actualType_visited = false;
        return actualType_value;
    }

    private String actualType_compute() {  return  "unknown";  }

    protected boolean getUseName_visited = false;
    // Declared in ErrorChecking.jrag at line 125
    public String getUseName() {
        if(getUseName_visited)
            throw new RuntimeException("Circular definition of attr: getUseName in class: ");
        getUseName_visited = true;
        String getUseName_value = getUseName_compute();
        getUseName_visited = false;
        return getUseName_value;
    }

    private String getUseName_compute() {  return  "";  }

    protected boolean expectedType_visited = false;
    // Declared in AssemblyTypeAnalysis.jrag at line 49
    public String expectedType() {
        if(expectedType_visited)
            throw new RuntimeException("Circular definition of attr: expectedType in class: ");
        expectedType_visited = true;
        String expectedType_value = getParent().Define_String_expectedType(this, null);
        expectedType_visited = false;
        return expectedType_value;
    }

}
