/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package ist.palcom.storage.test;

import ist.palcom.storage.persistent.PersistentStore;
import ist.palcom.storage.pfs.FileStorage;
import ist.palcom.storage.pfs.Storage;
import ist.palcom.storage.pfs.StorageException;

public class PersistenStoreTest {

    public static void testPersistenStore(Storage store) {
		
    	System.out.println("testPersistenStore: ");
    	System.out.println();
    	
    	int employeeID; 
    	String firstName;
        String lastName;
        int managerID;
        
        Employee empp = new Employee( );

        employeeID = 1;
    	firstName = "K";
        lastName= "Tollmar";
        managerID = 2;

        Employee emp1 = new Employee(employeeID, firstName, lastName, managerID );
    	
    	employeeID = 2;
    	firstName = "T";
        lastName= "Kalling";
        managerID = 3;

        Employee emp2 = new Employee(employeeID, firstName, lastName, managerID );
        
    	employeeID = 3;
    	firstName = "A";
        lastName= "Malm";
        managerID = 0;

        Employee emp3 = new Employee(employeeID, firstName, lastName, managerID );

    	employeeID = 4;
    	firstName = "M";
        lastName= "Lathinen";
        managerID = 1;

        Employee emp4 = new Employee(employeeID, firstName, lastName, managerID );

    
        // 1: Add 
    	System.out.println("");
    	System.out.println("testPersistenStore: add");
    	PersistentStore ps = new PersistentStore(store, "ps.txt", true);
    	System.out.print("add:");
    	System.out.println(emp1.toString());
    	ps.add(emp1);
    	ps.print(empp);
    	ps.close();

    	// 2: Open
    	System.out.println("");
    	System.out.println("testPersistenStore: open: ps.txt");
    	ps = new PersistentStore(store, "ps.txt", false);
    	ps.print(empp);
    	ps.close();

    	// 3: Add
    	System.out.println("");
    	System.out.println("testPersistenStore: add");
    	ps = new PersistentStore(store, "ps.txt", false);
    	ps.print(empp );

    	System.out.print("add:");
    	System.out.println(emp2.toString());
    	ps.add(emp2);
    	ps.print(empp);

    	System.out.print("add:"); 
    	System.out.println(emp3.toString());
    	ps.add(emp3);
    	ps.print(empp ); 	
    	
    	ps.close();
    	
    	// 4: Set
    	System.out.println("");
    	System.out.println("testPersistenStore: set");

    	ps = new PersistentStore(store, "ps.txt", false);
    	ps.print(empp );

    	System.out.print("set: 1 ");
    	System.out.println(emp4.toString());
    	ps.set(1,emp4);
    	ps.print(empp );

    	ps.close();

    	// 5: Delete
    	System.out.println("");
    	System.out.println("testPersistenStore: delete");

    	ps = new PersistentStore(store, "ps.txt", false);
    	ps.print(empp );

    	System.out.println("delete: 1 ");
    	ps.delete(1);
    	ps.print(empp );

    	ps.close();

    	// 6: Check
    	System.out.println("");    	
    	System.out.println("testPersistenStore: open: ps.txt");

    	System.out.println("open: ps.txt");
    	ps = new PersistentStore(store, "ps.txt", false);
    	ps.print(empp );
    	
    	ps.close();
    	
    	// 7: Delete file
    	System.out.println("");
    	System.out.println("testPersistenStore: delete file");

    	System.out.println("delete file: ps.txt");
    	try {
			store.delete("ps.txt");
		} catch (StorageException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

    	System.out.println("done");
    }

    public static void main(String[] args) {
        Storage store = new FileStorage("files");        
        //Storage store = new ByteStorage("files");
        PersistenStoreTest.testPersistenStore(store);
    }
}
